/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: xtime.h,v 1.2 1993/10/06 16:47:56 mura Exp $
 */

#ifndef __sys_xtime_h__
#define __sys_xtime_h__

#ifndef __cdecl_h__
#include <cdecl.h>
#endif

#ifndef __time_h__
#include <time.h>
#endif

#ifndef __ontime_defined__
#define __ontime_defined__
struct _ontime {
    int_ sec;
    int_ day;
};
#endif

#define _TZADJUST (-9 * 60 * 60)

extern struct _ontime _inclock;
extern struct _ontime _chclock;
extern struct tm _gmtm;

_EXTERN (clock_t __const _ontime2clock (struct _ontime));
_EXTERN (int_ __const _isleap (int_, int_));
_EXTERN (int_ __const _getleaps (int_));
_EXTERN (int_ __const _getmday (int_, int_));
_EXTERN (int_ __const _getyday (int_, int_));
_EXTERN (struct _ontime __const _diffontime (struct _ontime, struct _ontime));
_EXTERN (struct tm _gmtime (const time_t *));
_EXTERN (struct tm _localtime (const time_t *));

#endif
