/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _assert.c,v 1.4 1994/07/27 13:46:19 mura Exp $
 */

/* System headers */
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/* Functions */
void __volatile _assert (const char *expression, int lineno, const char *fname)
{
    /* \ */
    fprintf (stderr, "Assertion failed: <%s> at line %d, in file %s\n",
					expression, lineno, fname);
    /* A{[g */
    abort ();
}
