/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: fcntl.c,v 1.1.1.1 1993/04/18 16:17:10 mura Exp $
 */

/* System headers */
#include <fcntl.h>
#include <unistd.h>
#include <limits.h>
#include <sys/dos.h>
#include <stdarg.h>
#include <errno.h>
#include <sys/xunistd.h>

/* Functions */
int fcntl (int fd, int cmd, ...)
{
    int tofd;
    va_list ap;

#ifdef EBADF_CHECKER
    /* t@Cnh`FbN */
    if (_usedfd (fd) < 0) {
	errno = EBADF;
	return -1;
    }
#endif

    /* cmd ͂ */
    switch (cmd) {

    case F_DUPFD:
	/* dupt@Cnh߂ */
	va_start (ap, cmd);
	for (tofd = va_arg (ap, int); tofd < OPEN_MAX; tofd++)
	    if (_fddb[tofd].inuse == 0)
		break;
	va_end (ap);

	/* tȂ? */
	if (tofd >= OPEN_MAX) {
	    errno = EMFILE;
	    return -1;
	}

	/* dup2 R[ */
	return dup2 (fd, tofd);

    case F_GETFL:
	/* t@CXe[^X{ANZXtOo */
	return _fddb[fd].oflag & (O_ACCMODE | O_STSMODE);

    case F_SETFL:
	/* t@CXe[^XtOݒ肷 */
	va_start (ap, cmd);
	_fddb[fd].oflag &= ~O_STSMODE;
	_fddb[fd].oflag |= va_arg (ap, int) & O_STSMODE;
	va_end (ap);
	return 0;

    }

    /* cmd s */
    errno = EINVAL;
    return -1;
}
