/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _print.c,v 1.3 1993/11/13 06:33:11 mura Exp $
 */

/*
** ̊֐ stdio  _fmtout Ȃǂł܂ł̓ʂ̂ȂƂ
** gpɂƂǂ߂邱ƁB{I printf ̎dl̓T|[gĂ
** A̎wAs_̈͂łȂB炸B
**
** gpłtH[}bg@F %d %s %x %c
*/

/* System headers */
#include <string.h>
#include <stdarg.h>
#include <sys/dos.h>
#include <sys/xglob.h>

/* File scope functions */
static void output (const char *ptr, size_t size)
{
    /* oׂ͂cĂ胋[v */
    while (size-- > 0)
	_dos_c_putc (*ptr++);
}

/* File scope functions */
static size_t dec (char *buffer, int val, int radix)
{
    int minus = 0;
    char *ptr, temp[256];
    static const char digits[16] = "0123456789abcdef";

    /* ptr ̏ */
    ptr = temp + sizeof temp;

    /* Ō EOS ł */
    *--ptr = '\0';

    /* oĐΒl */
    if (val < 0) {
	val = -val;
	minus = 1;
    }

    /* val łȏ㑱 */
    do {
	*--ptr = digits[val % radix];
	val /= radix;
    } while (val > 0);

    /*  */
    if (minus)
	*--ptr = '-';

    /* buffer ɃRs[ */
    strcpy (buffer, ptr);

    return strlen (ptr);
}

/* Functions */
void _print (const char *format, ...)
{
    size_t size;
    va_list ap;
    char ch, dat, *p;
    char temp[256];

    /* ւ̃|C^o */
    va_start (ap, format);

    /* tH[}bg͂ */
    while ((ch = *format) != 0) {

	/* %`Ȃ΃tH[}bgo͎w */
	if (ch == '%') {
	    switch (*++format) {
	    case 'd':
		size = dec (temp, va_arg (ap, int), 10);
		output (temp, size);
		format++;
		break;
	    case 'x':
		size = dec (temp, va_arg (ap, int), 16);
		output (temp, size);
		format++;
		break;
	    case 'c':
		dat = (char) va_arg (ap, int);
		output (&dat, 1);
		format++;
		break;
	    case 's':
		size = strlen (p = va_arg (ap, char *));
		output (p, size);
		format++;
		break;
	    default:
		output (format++, 1);
		break;
	    }
	}
	else {
	    output (format++, 1);
	}

    }

    /* ւ̃|C^ */
    va_end (ap);
}
