/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _sysroot.c,v 1.2 1993/08/16 13:34:27 mura Exp $
 */

/* System headers */
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/xglob.h>

/* Macros */
#define DEFAULT_DRIVE "A:"

/* Functions */
char *_sysroot (char *buffer, const char *path, size_t size)
{
    char *root, *src;
    char fname[PATH_MAX + 1];

    /* ϐ SYSROOT  */
    if ((root = getenv ("SYSROOT")) != NULL) {

	/* 炩ߒ`FbN */
	if (strlen (root) >= PATH_MAX) {
	    errno = ENAMETOOLONG;
	    return 0;
	}

	/* SYSROOT ݒ肳ĂΌʂ $SYSROOT$path */
	src = _dellastsep (strcpy (fname, root));

    }
    else {

	/* ĂȂΌʂ $DEFAULT_DRIVE$path ƂȂ */
	src = DEFAULT_DRIVE;

    }

    /* `FbN */
    if (strlen (src) + strlen (path) + 1 > size) {
	errno = ENAMETOOLONG;
	return 0;
    }

    /* t@C𐶐 */
    return strcat (strcpy (buffer, src), path);
}
