/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _is68881.c,v 1.2 1993/06/24 17:29:33 mura Exp $
 */

/* System headers */
#include <sys/dos.h>
#include <sys/iocs.h>
#include <sys/xmath.h>

/*
** X68030 Human system work area (supervisor)
*/

/* Macros */
#define CPUTYPE() (unsigned char) _iocs_b_bpeek ((void *) 0xcbc) /* CPU type */
#define FPUFLAG() (unsigned char) _iocs_b_bpeek ((void *) 0xcbd) /* FPU type */
#define MMUFLAG() (unsigned char) _iocs_b_bpeek ((void *) 0xcbe) /* MMU type */

/* External functions */
double _f_is68881 (void);
double _fpu_is68881 (void);

/* Functions */
int _is68881 (void)
{
    xdouble_t value;

    /* FPU 邩 */
    if (FPUFLAG ()) {

	/* 68881 `FbN */
	value.d = _f_is68881 ();
    }

    else {
	int ssp;
	unsigned short buf;

	/* Co-Processor I/O ANZX\ FPU RESPONSE CIR(R) */
	if (_dos_bus_err ((void *) _FPU_IO, &buf, 2) != 0)
	    return -1;

	/* X[p[oCU[[h */
	ssp = _dos_super (0);

	/* 68881 `FbN */
	value.d = _fpu_is68881 ();

	/* [U[[h */
	if (ssp > 0)
	    _dos_super (ssp);

    }

    /* ߂ */
    return (value.ll == 0ULL) ? 1 : 0;
}
