/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _iscopro.c,v 1.4 1993/11/13 06:33:30 mura Exp $
 */

/* System headers */
#include <sys/dos.h>
#include <sys/iocs.h>
#include <sys/xmath.h>

/*
** X68030 Human system work area (supervisor)
*/

/* Macros */
#define CPUTYPE() (unsigned char) _iocs_b_bpeek ((void *) 0xcbc) /* CPU type */
#define FPUFLAG() (unsigned char) _iocs_b_bpeek ((void *) 0xcbd) /* FPU type */
#define MMUFLAG() (unsigned char) _iocs_b_bpeek ((void *) 0xcbe) /* MMU type */

/* File scope functions */
static int ioflag (void)
{
    int result = 0;
    unsigned short buf;

    /* CPU  68000 ȊOȂ move from sr ͓߂ł */
    if (CPUTYPE() != 0) {
	result = _FLG_ILCPU;
    }

    /* Co-Processor I/O ANZX\ FPU RESPONSE CIR(R) */
    if (_dos_bus_err ((void *) _FPU_IO, &buf, 2) == 0) {

	/* I/O Co-Processor  */
	_fpuinit ();

	/* tOZbg */
	result |= _FLG_IOFPU;

    }

    /* ʂԂ */
    return result;
}

/* Functions */
char _iscopro (void)
{

    /* FPU  _FLG_FPU, _FLG_ILCPU ݒ(68020 ȍ~) */
    if (FPUFLAG ())
	_ohavefpu = _FLG_FPU | _FLG_ILCPU;

    /* łȂ I/O FPU 𒲂ׂ */
    else
	_ohavefpu = ioflag ();

    /* ʂԂ */
    return _ohavefpu;
}
