/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: mbbtombc.c,v 1.1 1993/11/13 06:33:49 mura Exp $
 */

/* System headers */
#include <mbstring.h>

/* File scope variables */
static const unsigned char ankcnv[] __attribute__ ((aligned (2))) =
    "@Ihfij{C|D^OPQRSTUVWXFGH"  /* 20-3f */
    "`abcdefghijklmnopqrstuvwxymnOQ"  /* 40-5f */
    "Mobp`";   /* 60-7e */

static const unsigned char katacnv[] __attribute__ ((aligned (2))) =
    "BuvAE@BDFHb[ACEGIJLNPRTVXZ\"    /* a1-bf */
    "^`cegijklmnqtwz}~JK"; /* c0-df */

static const unsigned char hiracnv[] __attribute__ ((aligned (2))) =
    "BuvAE["    /* a1-bf */
    "ĂƂȂɂʂ˂̂͂Ђӂւق܂݂ނ߂JK"; /* c0-df */

/* Functions */
int __const mbbtombc (int c)
{
    int flag = 0;

    /* Ђ炪ȕϊs? */
    if (c & 0x10000) {
	c &= 0xffff;
	flag = 1;
    }

    /* ANK ϊ */
    if (c >= 0x20 && c <= 0x7e) {

	/* oCg̔zƌȂ */
	const unsigned short *ank = (const unsigned short *) ankcnv;

	/* CfbNXvZ */
	c = (c - 0x20);

	/* e[uϊ */
	c = ank[c];

    }

    /* ȊOϊ */
    else if (c >= 0xa1 && c <= 0xdf) {

	/* oCg̔zƌȂ */
	const unsigned short *kana = (const unsigned short *)
					(flag ? hiracnv : katacnv);

	/* CfbNXvZ */
	c = (c - 0xa1);

	/* e[uϊ */
	c = kana[c];

    }

    /* ϊR[hԂ */
    return c;
}
