/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: mbctombb.c,v 1.1 1993/11/13 06:33:53 mura Exp $
 */

/* System headers */
#include <mbctype.h>
#include <mbstring.h>

/* Macros */
#define D(c) ((c) + 0x30) /* _ */
#define H(c) ((c) - 0x30) /* _ */

/* Macros */
#define MBC_HIRA_LOW  0x829f
#define MBC_HIRA_HIGH 0x82f1
#define MBC_KATA_LOW  0x8340
#define MBC_KATA_HIGH 0x8396
#define MBC_UPPER_LOW 0x8260
#define MBC_LOWER_LOW 0x8281
#define MBC_DIGIT_LOW 0x824f
#define MBC_PUNC_LOW  0x8140
#define MBC_PUNC_HIGH 0x8197

/* File scope variables */
static unsigned char punccnv[] = {
    ' ', '', '', ',', '.', '', ':', ';', '?', '!',   0,   0,   0, '`',
      0, '^',   0, '_',   0,   0,   0,   0,   0,   0,   0,   0,   0, '',
      0,   0, '/',   0, '~',   0, '|',   0,   0,   0,'\'',   0,'\"', '(',
    ')',   0,   0, '[', ']', '{', '}',   0,   0,   0,   0, '', '',   0,
      0,   0,   0, '+', '-',   0,   0,   0, '=',   0, '<', '>',   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0, '\\','$',   0,   0, '%', '#',
    '&', '*', '@'
};

static unsigned char kanacnv[] = {
       '',    '',    '',    '',    '',    '',    '',    '',    '',    '',
       '', D(''),    '', D(''),    '', D(''),    '', D(''),    '', D(''),
       '', D(''),    '', D(''),    '', D(''),    '', D(''),    '', D(''),
       '', D(''),    '', D(''),    '',    '', D(''),    '', D(''),    '',
    D(''),    '',    '',    '',    '',    '',    '', D(''), H(''),    '',
    D(''), H(''),    '', D(''), H(''),    '', D(''), H(''),    '', D(''),
    H(''),    '',    '',    '',    '',    '',    '',    '',    '',    '',
       '',    '',    '',    '',    '',    '',    '',      0,    '',      0,
         0,    '',    '', D(''),      0,      0
};

/* Functions */
int __const mbctombb (int c)
{
    int code;

    /* Ђ炪Ȃ? */
    if (ismbchira (c)) {

	/* ϊ\ȂΕϊ */
	if ((code = kanacnv[c - MBC_HIRA_LOW]) != 0)
	    c = code;

    }

    /* Ȃ? */
    else if (ismbckata (c)) {

	/* ϊ\ȂΕϊ */
	if ((code = kanacnv[c - MBC_KATA_LOW - (c > 0x837f ? 1 : 0)]) != 0)
	    c = code;

    }

    /* L? */
    else if (MBC_PUNC_LOW <= c && c <= MBC_PUNC_HIGH && c != 0x817f) {

	/* ϊ\ȂΕϊ */
	if ((code = punccnv[c - MBC_PUNC_LOW - (c > 0x817f ? 1 : 0)]) != 0)
	    c = code;

    }

    /* p啶? */
    else if (ismbcupper (c))
	c -= MBC_UPPER_LOW - 'A';

    /* p? */
    else if (ismbclower (c))
	c -= MBC_LOWER_LOW - 'a';

    /* ? */
    else if (ismbcdigit (c))
	c -= MBC_DIGIT_LOW - '0';

    /* _A_Kv? */
    if (c >= 0x80) {

	/* _ */
	if (c < 0xa0)
	    c += ('' << 8) + 0x30;

	/* _ */
	else if (0xdf < c && c < 0xff)
	    c += ('' << 8) - 0x30;

    }

    /* ϊR[hԂ */
    return c;
}
