/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: mbstok.c,v 1.1.1.1 1993/04/18 16:20:07 mura Exp $
 */

/* System headers */
#include <stddef.h>
#include <mbstring.h>
#include <sys/xmbstring.h>

/* Functions */
unsigned char *mbstok (unsigned char *str, const unsigned char *delim)
{
    int ch, bytes;
    unsigned char *token;
    static unsigned char *last;

    /* str == 0  last == 0 ̓G[ */
    if (str == 0 && (str = last) == 0)
	return 0;

    /* ̃f~^XLbv */
    while ((ch = mbsnextc (str)) != 0) {

	/* f~^? */
	if (mbschr (delim, ch) == 0)
	    break;

	/* |C^i߂ */
	str = mbsinc (str);

    }

    /* ̏I */
    if (ch == '\0') {
	last = 0;
	return 0;
    }

    /* g[NJnʒuL */
    token = str;

    /* f~^̌ */
    while ((ch = mbsnextc (str)) != 0) {

	/* f~^? */
	if (mbschr (delim, ch))
	    break;

	/* |C^i߂ */
	str = mbsinc (str);

    }

    /* ̏I肩? */
    if (ch == '\0') {
	last = 0;
	return token;
    }

    /* f~^̃oCg`FbN */
    bytes = _mblen (str);

    /* sȃoCg̓G[ */
    if (bytes <= 0)
	return 0;

    /* f~^ null Ŗ߂ */
    str[0] = '\0';
    if (bytes > 1)
	str[1] = '\0';

    /* Ō̈ʒuLĖ߂ */
    last = str + bytes;

    return token;
}
