/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _blkprof.c,v 1.3 1993/09/07 16:19:21 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/dos.h>
#include <sys/wait.h>
#include <sys/xprof.h>
#include <sys/xstart.h>

/* External varibles */
int _blcnt;				/* e[ugp */
int _blmax;				/* e[uTCY */
int _bluse;				/* vt@CstO */
struct _blkprof **_blbuf;		/* vt@Ce[u */

/* Functions */
void __bb_init_func (struct _blkprof *block)
{
    union wait r;

    /* profile e[u ͏Ă? */
    if (_blbuf == 0) {

	/* e[u */
	_blcnt = 0;
	_blmax = BLK_INITIAL_ALLOC_SIZE;
	_blbuf = (struct _blkprof **)
	    malloc (sizeof (struct _blkprof *) * _blmax);

    nomem:

	/* ? */
	if (_blbuf == 0) {
	    r.w_status = 0;
	    r.w_liberror = 1;
	    r.w_retcode = ENOMEM;
	    _dos_print ("libprof: virtual memory exhausted\r\n");
	    _dos_exit2 (r.w_status);
	}

	/* tO𗧂Ă */
	_bluse = 1;

    }

    /* obt@tȂΊg */
    else if (_blcnt >= _blmax - 1) {

	/* e[uXV */
	_blmax += BLK_ENLARGE_BUFFER_STEP;
	_blbuf = (struct _blkprof **)
	    realloc (_blbuf, sizeof (struct _blkprof *) * _blmax);

	/* Ƃ͓ */
	goto nomem;

    }

    /* ubNe[u݃tO */
    block->init = 1;

    /* ubNe[uo^ */
    _blbuf[_blcnt++] = block;
}

/* Functions */
void __display_block_profile (void)
{
    int i, blk;
    struct _blkprof *p;
    char buffer[256];

    /* ubNe[uo */
    for (i = 0; i < _blcnt; i++) {

	/* |C^o */
	p = _blbuf[i];

	/* vt@C̏o */
	printf ("\nProfile source %s : %d block(s)\n\n", p->file_name, p->size);

	/* ubNɃvt@Co */
	for (blk = 0; blk <  _blbuf[i]->size; blk++) {

	    /* ώZԂ\ */
	    snprintf (buffer, sizeof buffer,
		     "\tBlock no. %6d address %6X offset %6X : %10d time(s)\r\n",
		     blk,
		     (int) p->addr[blk],
		     (int) p->addr[blk] - (int) _psta,
		     p->count[blk]);

	    /* DOS R[ŕ\ */
	    _dos_print (buffer);

	}

    }
}
