/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * based on the contribution from Mariko.
 * --------------------------------------------------------------------
 * $Id: _fncprof.c,v 1.3 1993/09/07 16:19:26 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <interrupt.h>
#include <sys/dos.h>
#include <sys/iocs.h>
#include <sys/wait.h>
#include <sys/xprof.h>

/* External variables */
int _fpcnt;				/* e[ugp */
int _fpmax;				/* e[uTCY */
int _fpuse;				/* vt@CstO */
struct _fncprof **_fpbuf;		/* vt@Ce[u */

/* Functions */
void __ftime_start (void)
{
    union wait r;
    register struct _fncprof *ptr asm ("extern a2");

    /* profile obt@ȂΏ */
    if (_fpbuf == 0) {

	/* e[u */
	_fpcnt = 0;
	_fpmax = FNC_INITIAL_ALLOC_SIZE;
	_fpbuf = (struct _fncprof **)
	    malloc (sizeof (struct _fncprof *) * _fpmax);

    nomem:

	/* ? */
	if (_fpbuf == 0) {
	    r.w_status = 0;
	    r.w_retcode = ENOMEM;
	    r.w_liberror = 1;
	    _dos_print ("libprof: virtual memory exhausted\r\n");
	    _dos_exit2 (r.w_status);
	}

	/* tO𗧂Ă */
	_fpuse = 1;

    }

    /* obt@tȂΊg */
    else if (_fpcnt >= _fpmax - 1) {

	/* e[uXV */
	_fpmax += FNC_ENLARGE_BUFFER_STEP;
	_fpbuf = (struct _fncprof **)
	    realloc (_fpbuf, sizeof (struct _fncprof *) * _fpmax);

	/* Ƃ͓ */
	goto nomem;

    }

    /* ċAx 0 ȂΎԂL^ */
    if (ptr->call_c == 0) {

	/* JEg 0 ̎Ƀe[uɓo^ */
	if (ptr->count == 0)
	    _fpbuf[_fpcnt++] = ptr;

	/* JnԂL^ */
	ptr->wtime = _iocs_ontime ();

    }

    /* ċAxAĂяo񐔃JEg */
    ptr->call_c++;
    ptr->count++;

    /* ߂ */
    IRTS ();
}

/* Functions */
void __ftime_end (void)
{
    int now;
    register struct _fncprof *ptr asm ("extern a2");

    /* ċAxZA0 ȂΏ */
    if (--ptr->call_c <= 0) {

	/* ݂̃VXeNbN߂ */
	now = _iocs_ontime ();

	/* oߎԂZ */
	ptr->atime += now - ptr->wtime;

    }

    /* ߂ */
    IRTS ();
}

/* Functions */
void __display_function_profile (void)
{
    int i, now;
    double tim;
    char buffer[256];

    /* ֐Ƀ`FbN */
    for (i = 0; i < _fpcnt; i++) {

	/* v̊֐Όvm肳 */
	if (_fpbuf[i]->call_c) {

	    /* ݂̃VXeNbN߂ */
	    now = _iocs_ontime ();

	    /* oߎԂZ */
	    _fpbuf[i]->atime += now - _fpbuf[i]->wtime;

	}

    }

    /* ֐ɏo */
    for (i = 0; i < _fpcnt; i++) {

	/* ώZԂ߂ */
	tim = (double) _fpbuf[i]->atime / 100.0;

	/* ώZԂ\ */
	snprintf (buffer, sizeof buffer,
		 "Function %32s : %c%8.2f sec(s) : %10d time(s)\r\n",
		 _fpbuf[i]->name,
		 _fpbuf[i]->call_c ? '*' : ' ', tim,
		 _fpbuf[i]->count);

	/* DOS R[ŕ\ */
	_dos_print (buffer);

    }
}
