/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _harderr.c,v 1.2 1993/11/13 06:34:04 mura Exp $
 */

/* System headers */
#include <interrupt.h>
#include <sys/dos.h>
#include <sys/xsignal.h>

/* External varaibles */
hardfunc_t _harderr_handler;

/* Functions */
void _harderr (void (*func) ())
{
    /* nhL */
    _harderr_handler = (hardfunc_t) func;
}

/* Functions */
void __volatile _hardresume (int result)
{
    RETREG (value, d0);

    /* result ̒lɂĕ */
    switch (result) {

    case _HARDERR_ABORT:
	value = _TE_ABORT;		/* I (A) */
	break;

    case _HARDERR_FAIL:
	_doscall_escape (_DOSE_NOENT);	/* s (F) */
	break;

    case _HARDERR_IGNORE:
	value = _TE_IGNORE;		/*  (I) */
	break;

    case _HARDERR_RETRY:
	value = _TE_RETRY;		/* Ďs (R) */
	break;

    default:
	value = _TE_OLDVEC;		/* ȊO͌̃xN^ */
	break;

    }

    /* ۂ̏[` */
    _harderror_return ();
}

/* Functions */
void __volatile _hardretn (int dos_err_code)
{
    /* DOS R[𒆒fAĂяoƂ֖߂ */
    _doscall_escape (dos_err_code);
}
