* -*-Fundamental-*-
*
* PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
* --------------------------------------------------------------------
* This file is written by the Project C Library Group,  and completely
* in public domain. You can freely use, copy, modify, and redistribute
* the whole contents, without this notice.
* --------------------------------------------------------------------
* $Id: _intrtc.s,v 1.5 1994/11/26 14:55:48 mura Exp $
*

		.include	doscall.mac
		.include	iocscall.mac

		.xdef		__intrtc
		.xdef		__alarm_on
		.xdef		__rtccnt
		.xdef		__rtcnxt
		.xdef		saved_sr
		.xdef		saved_sp
		.xdef		saved_usp

		.xref		__oldrtc
		.xref		__sigparse
		.xref		__sigsetcnt
		.xref		__signal

S_ALRM:		.equ		$0107

RTC_MODE:	.equ		$e8a01b
RTC_RESET_CTRL:	.equ		$e8a01f
INDOS_FLAG:	.equ		$1c08

		.offset		0

info_mode:	.ds.l		1
info_code:	.ds.l		1
info_must:	.ds.l		1
info_pc:	.ds.l		1
info_usp:	.ds.l		1
info_sr:	.ds		1
size:

		.offset		0

areg:		.ds.l		7
dreg:		.ds.l		8
srreg:		.ds		1
pcreg:		.ds.l		1

sigparse:	.macro 		val
		pea		val
		jsr		(__sigparse)
		addq.l		#4,sp
		.endm

signal:		.macro 		val
		pea		val
		jsr		(__signal)
		addq.l		#4,sp
		.endm

usermode	.macro
		andi 		#.not.(1<<13),sr
		.endm

supermode:	.macro
		clr.l		-(sp)
		DOS		__SUPER
		.endm

		.cpu		68000

		.text

__intrtc::
		tst.l		(__alarm_on)		* alarmݒ蒆?
		beq		rteout			* Ⴄ

		subq.l		#1,(__rtccnt)		* --count
		bpl		rteout			* != 0 -> rte
		clr.l		(__rtccnt)		* clear rtccnt
		tst		(INDOS_FLAG)		* check inDOS
		beq		ok_go
		addq.l		#1,(__rtccnt)		* forcefully set to 1
		bra		rteout			* try next!!

ok_go:
		move.l		sp,(saved_sp)		* save sp
		movem.l		d0-d7/a0-a6,-(sp)
		move		(srreg,sp),d2		* d2 = sr
		move.l		(pcreg,sp),d1		* d1 = pc
		move		d2,(saved_sr)		* save sr
		move.l		usp,a4			* save usp
		move.l		a4,(saved_usp)

		moveq		#$03,d0
		and.b		(RTC_RESET_CTRL),d0	* 16Hz stop
		ori.b		#$0c,d0
		move.b		d0,(RTC_RESET_CTRL)

		movea.l		sp,a3			* a3 = ssp
		move.l		usp,a4			* a4 = usp
*
* user stack
*
		usermode				* user mode
		link		a5,#-size		* struct info
		move.l		#S_ALRM,(info_code,a7)	* info.code = S_ALRM
		move.l		d1,(info_pc,a7)		* info.pc = d1(pc)
		move.l		a4,(info_usp,a7)	* info.usp = usp
		move		d2,(info_sr,a7)		* info.sr = d2(sr)
		sigparse	(a7)			* _sigparse (info)
		move.l		d0,d3
		bmi		unknown
		signal		(a7)			* _signal (info)
		move.l		d0,d3
unknown:
		unlk		a5
		supermode				* super visor
*
* supervisor stack
*
		movea.l		a3,sp			* sp  = a3 (ssp)
		move.l		a4,usp			* usp = a4 (usp)
		tst.l		d3
		bmi		oldvec			* if (err)
		bne		done
		IOCS		__ABORTJOB		* abortjob ()
done:
		move.l		(__rtcnxt),d0		* get next interval
		ble		done2			* if next <= 0 then done2
		move.l		d0,-(sp)		* push arguments
		move.l		d0,-(sp)
		jsr		(__sigsetcnt)		* reset timer
		addq.l		#8,sp
done2:
		movem.l		(sp)+,d0-d7/a0-a6
rteout:
		rte
oldvec:
		movem.l		(sp)+,d0-d7/a0-a6
		move.l		(__oldrtc),-(sp)
		rts					* jump to old verctor

		.bss

__alarm_on::	.ds.l		1			* alarmLǂ
__rtccnt::	.ds.l		1
__rtcnxt::	.ds.l		1
saved_sr::	.ds		1
saved_sp::	.ds.l		1
saved_usp::	.ds.l		1

		.end
