/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _sigdisp.c,v 1.1.1.1 1993/04/18 16:20:45 mura Exp $
 */

/* System headers */
#include <signal.h>
#include <string.h>
#include <sys/xsignal.h>

/* External variables */
volatile einfo_t _sigpendinginfo[SIG_MAX];
volatile sigset_t _sigmask;
volatile sigset_t _sigpendingset;

/* Functions */
int _sigdispatch (void)
{
    int sig;
    einfo_t *errorinfo;
    sigset_t _maskedsig;
    sigset_t _oldmask;
    void (*function) (int);

    /* JgvZX}XNEv */
    _maskedsig = _sigpendingset & ~_sigmask;

    /* pending Ă? */
    if (_maskedsig == 0)
	return -1;

    /* JgvZX}XNۑ */
    _oldmask = _sigmask;

    /* sig  1 o */
    sig = ffs (_maskedsig) - 1;

    /* VOi}XN */
    _sigmask |= (1 << SIGALRM) | (1 << sig) | _sigactions[sig].sa_mask;

    /* pending O */
    _sigpendingset &= ~(1 << sig);

    /* ֐ƁAG[o */
    function  = _sigactions[sig].sa_handler;
    errorinfo = (einfo_t *) &_sigpendinginfo[sig];

    /* SA_RESETHAND Ȃ΃nhɖ߂ */
    if (_sigactions[sig].sa_flags & SA_RESETHAND)
	_sigactions[sig].sa_handler = SIG_DFL;

    /* SIG_DFL Ȃ΃ftHg̃nhĂяo */
    if (function == SIG_DFL)
	_sigdfl (sig, errorinfo);

    /* Ȃ΃[U[`nhĂяo */
    else {
	_pause = 0;
	(*(void (*) (int, einfo_t *)) function) (sig, errorinfo);
    }

    /* }XNɖ߂ */
    _sigmask = _oldmask;

    /*  */
    return 0;
}
