/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: sigaction.c,v 1.1.1.1 1993/04/18 16:21:02 mura Exp $
 */

/* System headers */
#include <errno.h>
#include <signal.h>
#include <sys/dos.h>
#include <sys/xsignal.h>

/* Functions */
int sigaction (int sig, const struct sigaction *act, struct sigaction *oact)
{
    volatile struct sigaction *sgp;

    /* sig ͈̔̓`FbN */
    if (sig < 1 || sig >= SIG_MAX || (act && sig == SIGKILL)) {
	errno = EINVAL;
	return -1;
    }

    /* sigaction ̃AhX𓾂 */
    sgp = &_sigactions[sig];

    /*  sigaction ۑ */
    if (oact)
	*oact = *sgp;

    /* V sigaction Rs[ */
    if (act) {

	/* \̂Rs[ */
	*sgp = *act;

	/*  SIGINT Ȃ breakck 𑀍삷 */
	if (sig == SIGINT)
	    _dos_breakck (act->sa_handler == SIG_IGN ? 2 : 1);

    }

    /*  */
    return 0;
}
