* -*-Fundamental-*-
*
* PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
* --------------------------------------------------------------------
* This file is written by the Project C Library Group,  and completely
* in public domain. You can freely use, copy, modify, and redistribute
* the whole contents, without this notice.
* --------------------------------------------------------------------
* $Id:$
*

		.include	doscall.mac

		.xref		__sigmask
		.xref		saved_sr
		.xref		saved_sp
		.xref		saved_usp

		.ifndef		FPU
		.xref		__ohavefpu
FLG_FPU_BIT:	.equ		2
		.endif

* sigjmp_buf
		.offset		0
ret:		.ds.l		1
dregs:		.ds.l		5
aregs:		.ds.l		5
fpregs:		.ds.x		6
sigmask:	.ds.l		1

		.offset		4

environment:	.ds.l		1
rval:		.ds.l		1

		.cpu		68000

		.text

_siglongjmp::
		move.l		(rval,sp),d0
		bne		do_jmp
		moveq		#1,d0
do_jmp:
		movea.l		(environment,sp),a0
		move.l		(sigmask,a0),d0
		bmi		skip_restore
		move.l		d0,(__sigmask)
skip_restore:
		movem.l		(a0)+,d1/d3-d7/a3-a7	* ret / dregs / aregs
		.ifndef		FPU
		btst		#FLG_FPU_BIT,(__ohavefpu)
		beq		no_fpu
		.endif
		.cpu		68020
		fmovem.x	(a0),fp2-fp7		* fpregs
		.cpu		68000
no_fpu:
		clr.l		-(sp)
		DOS		__SUPER
		addq.l		#4,sp
		movea.l		(saved_sp),sp
		movea.l		(saved_usp),a1
		move.l		a1,usp
		move		(saved_sr),(sp)
		move.l		d1,(2,sp)		* ret
		rte

		.end
