/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: sigprocmask.c,v 1.2 1994/05/02 16:47:46 mura Exp $
 */

/* System headers */
#include <signal.h>
#include <errno.h>
#include <sys/xsignal.h>

/* Functions */
int sigprocmask (int how, sigset_t *set, sigset_t *oset)
{
    sigset_t newmask;

    /* ̃}XNۑ */
    if (oset)
	*oset = _sigmask;

    /* set  null pointer Ȃ _sigmask ͕ύXȂ */
    if (set) {

	/* how ɉĐV mask vZ */
	switch (how) {
	case SIG_BLOCK:
	    newmask = _sigmask | *set;
	    break;
	case SIG_UNBLOCK:
	    newmask = _sigmask & ~(*set);
	    break;
	case SIG_SETMASK:
	    newmask = *set;
	    break;
	default:
	    errno = EINVAL;
	    return -1;
	}

	/* V}XNݒ肷 */
	_sigmask = newmask;
    }

    /* V}XN signal dispatching  */
    while (_sigdispatch () >= 0);

    /*  */
    return 0;
}
