/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _ctors.c,v 1.1.1.1 1993/04/18 16:21:33 mura Exp $
 */

/* System headers */
#include <sys/xstart.h>

/* Macros */
#define _CTOR_LEAD  0x4afc
#define _CTOR_TRAIL 0x432b
#define _DTOR_LEAD  0x4afc
#define _DTOR_TRAIL 0x432d

/* File scope functions */
static void _srchmagic (unsigned short lead, unsigned short trail)
{
    unsigned short *ptr;
    void (*funcptr) (void);

    /* |C^ */
    ptr = (unsigned short *) _psta;

    /* eLXg̈̏I܂ magic code  */
    while (ptr < (unsigned short *) _dsta) {

	/* leading word 1 T */
	if (*ptr++ != lead)
	    continue;

	/* leading word 2 T */
	if (*ptr++ != lead)
	    continue;

	/* leading word 3 T */
	if (*ptr++ != lead)
	    continue;

	/* leading word 4 T */
	if (*ptr++ != lead)
	    continue;

	/* leading word 5 T */
	if (*ptr++ != lead)
	    continue;

	/* trailing word 1 T */
	if (*ptr++ == trail) {

	    /* funcptr o */
	    funcptr = (void (*) (void)) *((int *) ptr)++;

	    /* ֐Ăяo */
	    (*funcptr) ();

	}
    }
}

/* Functions */
void _ctors (void)
{
    /* O[oRXgN^Ăяo */
    _srchmagic (_CTOR_LEAD, _CTOR_TRAIL);
}

/* Functions */
void _dtors (void)
{
    /* O[ofXgN^Ăяo */
    _srchmagic (_DTOR_LEAD, _DTOR_TRAIL);
}
