/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * based on the contribution from sa2c (NIIMI Satoshi).
 * --------------------------------------------------------------------
 * $Id: _enhupair.c,v 1.2 1994/07/27 13:48:05 mura Exp $
 */

/* System headers */
#include <string.h>
#include <sys/xstart.h>

/* Macros */
#define PUT(c)		\
(void) ({		\
    if (q < max)	\
	*q++ = c;	\
    else		\
	return -1;	\
})

/* HUPAIR GR[hہAǂȃNI[gK؂ */
static __inline int decide_quote (const char *arg)
{
    unsigned char ch;

    /* ̓NI[g */
    if (*arg == 0)
	return '"';

    /* arg ͂ */
    while ((ch = *arg++) != '\0') {

	/* " Ⴕ ' ΁AK */
	if (ch == '"' || ch == '\'')
	    return ch ^ ('"' ^ '\'');

	/* 󔒂 " ܂ ' ̂ǂ炩 */
	if (ch == ' ') {

	    while ((ch = *arg++) != '\0') {

		/*  " Ⴕ ' ΁AK */
		if (ch == '"' || ch == '\'')
		    return ch ^ ('"' ^ '\'');
	    }

	    /* ɉȂ " K */
	    return '"';
	}
    }

    /* ɕKvȂ */
    return 0;
}

/* Functions */
int _enhupair (const char *argv0,
	       char *const *argv, char *cmdline, int bufsiz)
{
    int ret;
    unsigned char c, quote;
    char *q;
    const char *arg;
    const char *max;

    /* obt@I[vZ */
    q = cmdline;
    max = q + bufsiz - (strlen (argv0) + 1);

    /* R}hC̒p̗̈ */
    PUT ('\0');

    /* argv zp[X */
    while ((arg = *argv++) != '\0') {

	/* K؂ȁuŏ́vNI[gI */
	quote = decide_quote (arg);

	/* NI[gKvȂ炻} */
	if (quote)
	    PUT (quote);

	/*  n p[X */
	while ((c = *arg++) != '\0') {

	    /* quote ꂽꍇ */
	    if (c == quote) {

		/* NI[g... */
		PUT (quote);

		/* NI[g؂ւ */
		quote = (c == '"') ? '\'' : '"';

		/* NI[gĊJ */
		PUT (quote);

	    }

	    /* c o */
	    PUT (c);

	}

	/* NI[gKvȂ炻} */
	if (quote)
	    PUT (quote);

	/* ̈ΊԂɋ󔒂 */
	if (*argv)
	    PUT (' ');

    }

    /* Ō EOS ł */
    PUT ('\0');

    /* ̌ argv0  */
    strcpy (q, argv0);

    /* cmdline - 8  #HUPAIR ʎq */
    strcpy (cmdline - 8, _hupair_mark);

    /* R}hC̒vZ */
    ret = (q - cmdline) - 2;

    /* ő 255 ܂łݒłȂ */
    *cmdline = (ret > 255) ? 255 : ret;

    /* oCgԂ */
    return ret;
}
