/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _start.c,v 1.8 1994/07/31 17:23:28 mura Exp $
 */

/* System headers */
#include <sys/types.h>
#include <sys/dos.h>
#include <sys/iocs.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <limits.h>
#include <signal.h>
#include <stdio.h>
#include <sys/wait.h>
#include <sys/xstart.h>
#include <sys/xmath.h>
#include <sys/xstat.h>
#include <sys/xsignal.h>
#include <sys/xtime.h>
#include <sys/xstdio.h>
#include <sys/xunistd.h>
#include <sys/xresource.h>

/* Macros */
#define MEMCHK(end) ({	\
    if ((void *) _memcp->block_end <= (void *) (end))	\
	goto mem_error;	\
    })

/* Functions */
void __volatile _start (struct _mep *mp)
{
    extern int main (int, char **, char **);

    /* NbŇvJnԂL^ */
    _inclock = _iocs_ontime2 ();

    /*
    ** (1) ŒZNV̈ʒuAyуR}hC̉
    */

    {
	char* end;

	/* TEXT, DATA, BSS ZNV̈ʒu肷 */
	_memcp = mp;
	_procp = (struct _psp *) ((char *) mp + sizeof (struct _mep));
	_psta = (void *) ((char *) _procp + sizeof (struct _psp));
	_dsta = _procp->heap;
	_bsta = _procp->bss;

	/* R}hC̏ */
	_csta = _procp->stack;
	_comline = _procp->comline + 1;
	end = _csta + strlen (_comline) + 1;
	MEMCHK (end);

	/* R}hC𕪊 */
	_argc = _dehupair (_comline, _csta);

	/* ARGVBUF 𐶐 */
	_argv = _vsta = PAD (end);
	end = _vsta + sizeof (char *) * (_argc + 2);
	MEMCHK (end);
	_argc = _enargv (_procp, _argc, _argv, _csta);
    }

    /*
    ** (2) ϐGA̎荞݁AyщσTCYZNV̈ʒu
    */

    {
	char *rp, *wp, **vector;
	int n;

	/* GAɃRs[ */
	_esta = PAD (_vsta + sizeof (char *) * (_argc + 1));
	wp = _esta;
	rp = _procp->env;

	{
	    char *end = wp + 1;

	    if ((int)rp >= 0)
		end += *(int *)rp;
	    MEMCHK (end);
	}

	n = 1;
	if ((int)rp >= 0) {
	    rp += sizeof (int);
	    while (*rp) {
		n++;
		while ((*wp++ = *rp++) != '\0')
		    ;
	    }
	}

	/* Ō null őł~߂ */
	*wp++ = '\0';

	/* ENVBUF 쐬 */
	_fsta = PAD (wp);
	MEMCHK (_fsta + sizeof (char *) * n);
	_envp = environ = vector = (char **) _fsta;
	rp = _esta;
	while (*rp) {
	    *vector++ = rp;
	    while (*rp++)
		;
	}

	/* z̍Ō͏ null pointer */
	*vector++ = 0;

	/* X^bNAq[vʒuvZ */
	_ssta = PAD (vector);
	_hsta = PAD (_ssta + _stacksize);
	_last = PAD (_hsta + _heapsize);
	_mmax = _memcp->block_end;
    }

    /*
    ** (3) X^bN̐ݒ
    */

    {
	/* [U[X^bN|C^̐ݒ */
	asm volatile ("move.l %0,sp" : /* no outputs */ : "g" (_hsta));

	/* ݂܂ł̃TCY SETBLOCK  */
	if (_dos_setblock (_procp, (int) _last - (int) _procp) < 0) {
	    union wait r;
mem_error:
	    r.w_status = 0;
	    r.w_liberror = 1;
	    r.w_retcode = ENOMEM;
	    _dos_print ("libc: setblock failed.\r\n");
	    _dos_exit2 (r.w_status);
	}
    }

    /*
    ** (4) e탂W[̏
    */

    {
#ifndef __HAVE68881__
	/* RvZbT`FbN */
	_havefpu = _iscopro ();
#endif

	/* resource limit ̒l荞 */
	_loadrlimits ();

	/* signal Jn */
	_siginit ();

	/* ᐅt@Cnh̏ */
	_finit ();

	/* t@CXg[̏ */
	_sinit ();

	/* w肪΃X[p[oCU[[h */
	if (_superman & _SUPER_GO)
	    _SSP = _dos_super (0);

	/* FLOAT tOĂ fpu_off */
	if (_superman & _SUPER_FLOAT)
	    _havefpu &= ~(_FLG_IOFPU | _FLG_FPU);

	/* ^C][̏ */
	tzset ();

    }

    /*
    ** (5) C++ ̃O[oRXgN^N
    */

    /* errno NA */
    errno = 0;

#ifdef __CPLUSPLUS_STARTUP__
    /* C++ ̃O[oRXgN^N */
    if (_cplusplus)
	_ctors ();
#endif

    /*
    ** (6) NƏI
    */

    /* main Ăяo */
    exit (main (_argc, _argv, _envp));
}
