/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _sopen.c,v 1.2 1993/05/06 13:03:30 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/xstdio.h>
#include <unistd.h>

/* Functions */
int _sopen (FILE *fp, const char *mode, int type)
{
    int unimd;
    int bufsiz;
    short flag;
    unsigned char *ptr;

    {
	char c;

	/* mode ̐擪 r,w,a 𔻕ʂ */
	switch (*mode++) {
	case 'r':
	    flag = _IOREAD;
	    break;
	case 'w':
	    flag = _IOWRITE | _IOCREAT | _IOTRUNC;
	    break;
	case 'a':
	    flag = _IOWRITE | _IOREAD | _IOCREAT | _IOAPPEND;
	    break;
	default:
	    errno = EINVAL;
	    return -1;
	}

	/* _fmode ŃftHg̃[h߂ */
	flag |= _fmode == O_BINARY ? _IOBIN : _IOTEXT;

	/* 㑱 +,b,t Cq𔻕ʂ */
	while ((c = *mode++) != 0) {
	    switch (c) {
	    case '+':
		flag |= _IOREAD | _IOWRITE;
		break;
	    case 'b':
		flag |= _IOBIN;
		break;
	    case 't':
		flag &= ~_IOBIN;
		break;
	    default:
		errno = EINVAL;
		return -1;
	    }
	}
    }

    {
	/* _IONBF ͎̎Õobt@𗘗p */
	if (type == _IONBF) {
	    bufsiz = 1;
	    ptr = fp->_nbuff;
	}

	/* obt@̃mۂ */
	else {
	    bufsiz = BUFSIZ;
	    flag |= _IOFREE;
	    if ((ptr = (unsigned char *) malloc (bufsiz)) == 0)
		return -1;
	}
    }

    {
	/* FILE \̂ݒ */
	fp->_bufsiz   = bufsiz;
	fp->_cnt      = 0;
	fp->_base     = ptr;
	fp->_ptr      = ptr;
	fp->_flag     = flag | type | _IOAPPLS;
	fp->_file     = -1;
	fp->_nback    = 0;
    }

    {
	/* Wo̓tO UNIX I[v[hɕϊ */
	if ((flag & _IOUPD) == _IOUPD)
	    unimd = O_RDWR;
	else if (flag & _IOWRITE)
	    unimd = O_WRONLY;
	else
	    unimd = O_RDONLY;

	/* CREAT tO */
	if (flag & _IOCREAT)
	    unimd |= O_CREAT;

	/* TRUNC tO */
	if (flag & _IOTRUNC)
	    unimd |= O_TRUNC;

	/* APPEND tO */
	if (flag & _IOAPPEND)
	    unimd |= O_APPEND;

	/* BINARY/TEXT tO */
	unimd |= (flag & _IOBIN) ? O_BINARY : O_TEXT;
    }

    return unimd;
}
