/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: fwrite.c,v 1.3 1994/07/27 13:49:13 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/xstdio.h>

/* Functions */
size_t fwrite (const void *ptr, size_t size, size_t num, FILE *fp)
{
    size_t able;
    size_t total, bytes;

    /* oCg𒲂ׂ */
    if ((bytes = (unsigned int) (size * num)) <= 0)
	return 0;

    /* ݃[v */
    for (total = 0; bytes > 0; total += able) {

	/* ݑobt@ */
	if (_swrite (fp) < 0)
	    break;

	/* obt@ɏ߂ʂ𒲂ׂ */
	able = (bytes > fp->_cnt) ? fp->_cnt : bytes;

	/* obt@֓] */
	memcpy (fp->_ptr, ptr, able);

	/* |C^ */
	ptr += able;
	fp->_ptr += able;

	/* JE^ */
	bytes -= able;
	fp->_cnt -= able;

    }

    /* ǂݍ񂾍ڐԂ */
    return total / size;
}
