/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: pclose.c,v 1.2 1994/05/02 16:50:13 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/xstdio.h>

/* Functions */
int pclose (FILE *stream)
{
    int rc;
    epipe_t *ep;

    /* pCvf[^擾 */
    ep = &_pipes[stream->_file];

    /* I[vĂ邩? */
    if (ep->mode == inactive) {
	errno = EINVAL;
	return -1;
    }

    /* t@CN[Y */
    rc = fclose (stream);

    /* ݃[hȂ... */
    if (ep->mode == write_mode) {
	char *comline;

	/* R}hCobt@m */
	if ((comline = malloc (strlen (ep->command) + strlen (ep->temporary) + 4)) == 0)
	    return 0;

	/* sR}hC𐶐 */
	strcat (strcat (strcpy (comline, ep->command), " < "), ep->temporary);

	/* R}hs */
	rc = system (comline);

	/* obt@ */
	free (comline);

    }

    /* e|t@C폜 */
    unlink (ep->temporary);

    /* pCvf[^ */
    ep->mode = inactive;

    /* mۂ */
    free ((void *) ep->command);
    free ((void *) ep->temporary);

    /* rc Ԃ */
    return rc;
}
