/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: popen.c,v 1.2 1994/05/02 16:50:27 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/xstdio.h>

/* External variables */
epipe_t _pipes[OPEN_MAX];

/* Functions */
FILE *popen (const char *command, const char *mode)
{
    char *temp;
    epmode_t pmode;
    epipe_t *ep;
    FILE *fp;

    /* ǂݍ݃[h? */
    if (mode[0] == (char)'r')
	pmode = read_mode;

    /* ݃[h? */
    else if (mode[0] == (char)'w')
	pmode = write_mode;

    /* sȃ[h */
    else {
	errno = EINVAL;
	return 0;
    }

    /* e|t@C̃t@C𐶐 */
    if ((temp = tmpnam (0)) == 0)
	return 0;

    /* ǂݍ݃[hł... */
    if (pmode == read_mode) {
	char *comline;

	/* R}hCobt@m */
	if ((comline = malloc (strlen (command) + strlen (temp) + 4)) == 0)
	    return 0;

	/* R}hC𐶐 */
	strcat (strcat (strcpy (comline, command), " > "), temp);

	/* R}hs */
	system (comline);

	/* obt@ */
	free (comline);
    }

    /* e|t@CI[v */
    if ((fp = fopen (temp, mode)) == 0)
	return 0;

    /* pCv̎sf[^L^ */
    ep = &_pipes[fp->_file];
    ep->mode = pmode;
    ep->temporary = strdup (temp);
    ep->command = strdup (command);

    /* fp Ԃ */
    return fp;
}
