/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: rename.c,v 1.3 1994/07/27 13:49:32 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <sys/dos.h>
#include <sys/xglob.h>
#include <sys/xstdlib.h>

/* File scope functions */
static int pathchk (char *old, char *new)
{
    int len;

    /* OLDpX̒𒲂ׂ */
    len = strlen (old);

    /* OLDpX NEWpXɊ܂܂邩ׂ */
    if (new[len] == '/' && memcmp (old, new, len) == 0)
	return -1;

    /* ܂܂Ȃ */
    return 0;
}

/* File scope functions */
static int dirmove (const char *old, const char *new)
{
    int rc;

    /* old  new N */
    if ((rc = _dos_link (old, new)) < 0)
	return rc;

    /* old  unlink  */
    if ((rc = _dos_unlink (old)) < 0)
	return rc;

    /*  */
    return 0;
}

/* Functions */
int rename (const char *old, const char *new)
{
    int rc;
    int old_mode, new_mode;
    char old_path[PATH_MAX + 1];
    char new_path[PATH_MAX + 1];

    /* ΃pXɕϊ */
    _fullentry (old_path, old, sizeof old_path);
    _fullentry (new_path, new, sizeof new_path);

    /* NEW  OLD ܂܂ꂽ肵Ȃ? */
    if (pathchk (old_path, new_path) < 0) {
	errno = EINVAL;
	return -1;
    }

    /* OLD t@C̃[h𒲂ׂ */
    if ((old_mode = _dos_chmod (old_path, -1)) < 0) {
	errno = ENOENT;
	return -1;
    }

    /* t@C̕ύXȊO NEW t@C݂邩H */
    if ((new_mode = _dos_chmod (new_path, -1)) >= 0 && stricmp (old_path, new_path)) {

	/* t@C[hقȂ΃G[ */
	if ((old_mode ^ new_mode) & (_DOS_IFDIR | _DOS_IFREG)) {
	    errno = _DOS_ISDIR (old_mode) ? ENOTDIR : EISDIR;
	    return -1;
	}

	/* fBNgłɑ݂ꍇ͍폜 */
	if (_DOS_ISDIR (old_mode) && _DOS_ISDIR (new_mode)) {
	    if (_dos_rmdir (new_path) < 0) {
		errno = ENOTEMPTY;
		return -1;
	    }
	}

	/* t@C݂ꍇ͍폜 */
	else if ((rc = _dos_delete (new_path)) < 0) {
	    errno = _errcnv (rc);
	    return -1;
	}

    }

    /* t@C̓fBNg? */
    if (_DOS_ISDIR (old_mode)) {

	/* l[^fBNg̈ړ */
	if ((rc = dirmove (old_path, new_path)) < 0) {
	    errno = _errcnv (rc);
	    return -1;
	}

    }
    else {

	/* l[^ʏt@C̈ړ */
	if ((rc = _dos_rename (old_path, new_path)) < 0) {
	    errno = _errcnv (rc);
	    return -1;
	}

    }

    /*  */
    return 0;
}
