/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: setvbuf.c,v 1.4 1993/09/07 16:20:23 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>

/* Functions */
int setvbuf (FILE *fp, char *buf, int type, size_t size)
{
    int bufsiz;

    /* type  FBF,LBF,NBF ȊOȂ΃G[ */
    if (type != _IOFBF && type != _IOLBF && type != _IONBF)
	return -1;

    /* Ƀobt@삪sȂĂ鎞̓G[ */
    if (fp->_flag & (_IOR | _IOW))
	return -1;

    /* _IONBF ͎̎Õobt@𗘗p */
    if (type == _IONBF) {
	bufsiz = 1;
	buf = (char *) fp->_nbuff;
    }

    /* buf  null pointer ȂΎOŗpӂ */
    else {
	bufsiz = size;
	if (buf == 0) {
	    type |= _IOFREE;
	    if ((buf = (char *) malloc (bufsiz)) == 0)
		return -1;
	}
    }

    /* ꍇɌ荡gĂobt@ */
    if (fp->_flag & _IOFREE) {
	fp->_flag &= ~_IOFREE;
	free (fp->_base);
    }

    /* obt@TCYA|C^ */
    fp->_flag &= ~(_IOLBF | _IOFBF | _IONBF);
    fp->_flag |= type;
    fp->_base = (unsigned char *) buf;
    fp->_ptr = (unsigned char *) buf;
    fp->_bufsiz = bufsiz;
    fp->_cnt = 0;
    fp->_nback = 0;

    /* I */
    return 0;
}
