/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: tempnam.c,v 1.1.1.1 1993/04/18 16:23:19 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/xglob.h>
#include <sys/xstdio.h>

/* Functions */
char *tempnam (const char *dir, const char *prefix)
{
    int last;
    char *buffer;
    struct stat st;

    /* L_tmpnam ̃obt@mۂ */
    if ((buffer = (char *) malloc (L_tmpnam)) == 0)
	return 0;

    /* prefix wȂ tmp_ ɂ */
    if (prefix == 0)
	prefix = "tmp_";

    /* dir ƂfBNg𒲂ׂ */
    if (dir == 0 || stat (dir, &st) < 0 || S_ISDIR (st.st_mode) == 0)
	dir = getenv ("temp") ? : P_tmpdir;

    /* dir/ Ƃ template 쐬 */
    _addlastsep (strcpy (buffer, dir));

    /* dir/prefix  prefix  5 ܂ */
    last = strlen (buffer);
    strcpy (buffer + last, prefix);
    buffer[last + 5] = '\0';

    /* dir/prefixXXXXXX 쐬 */
    strcat (buffer, "XXXXXX");

    /* mktemp R[At@C𐶐 */
    return mktemp (buffer);
}
