/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _getdriveno.c,v 1.2 1993/06/06 06:09:51 mura Exp $
 */

/* System headers */
#include <errno.h>
#include <ctype.h>
#include <sys/dos.h>
#include <sys/xglob.h>
#include <sys/xstdlib.h>

/* Functions */
int _getdriveno (const char *path)
{
    int drv;

    /* hCuԍvZ */
    drv = _tolower ((unsigned char) path[0]) - 'a';

    /* hCuꍇ NAMESTS */
    if (drv < 0 || ('z' - 'a') < drv || path[1] != ':') {
	struct _namestbuf nsbuf;

	if (_dos_namests (path, &nsbuf) < 0) {
	    errno = ENOENT;
	    return -1;
	}
	drv = (int) nsbuf.drive;
    }

    /* hCuԍԂ */
    return drv;
}
