/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _ma_new.c,v 1.3 1994/07/27 13:49:53 mura Exp $
 */

/* System headers */
#include <stdlib.h>
#include <limits.h>
#include <sys/xstart.h>
#include <sys/xstdlib.h>

#ifdef __LIBSXC__

/* External variables */
int _ma_fnum;
char *_ma_flist;
char *_ma_lptr = 0;
extern size_t _SX_GETMEM_SIZE;

#else

/* External variables */
int _ma_fnum;
char *_ma_flist;
char *_ma_lptr;

#endif

/* Functions */
#ifdef __LIBSXC__
static __inline void *_SX_GET_PTR (size_t size)
{
    register void *reg_d0 asm ("d0");

    /* CCAZuWJ */
    asm volatile ("move.l %1,-(sp)\n\t"
		  "dc.w $a01e\n\t"
		  "addq.w #4,sp"
		  : "=r" (reg_d0)
		  : "g" (size)
		  : "a0");

    /* ʂԂ */
    return reg_d0;
}
#endif

/* Functions */
char *_ma_new (size_t size)
{
#ifdef __LIBSXC__

    char *alloc;
    size_t newsize = _SX_GETMEM_SIZE;

    /* vTCYl傫vTCYm */
    if (size > _SX_GETMEM_SIZE)
	newsize = size;

    /* Vq[vubNm */
    if ((alloc = _SX_GET_PTR (newsize + 12)) == 0)
	return 0;

    /* ЂƂÕq[vubNoĂ */
    *(long *) alloc = (long) _ma_lptr;
    _ma_lptr = alloc;

    /* I[ʎq */
    alloc += 8;
    MA_BFLAG (alloc) = MA_VALUE (MA_EXIT, 0);
    MA_FFLAG (alloc + newsize) = MA_VALUE (MA_EXIT, 0xffffff);

    /* Ŝ󂫃ubNXgɓo^ */
    MA_FFLAG (alloc) = MA_VALUE (MA_FREE, newsize);
    MA_BFLAG (alloc + newsize) = MA_VALUE (MA_FREE, newsize);
    _ma_add (alloc);

    /* ̌ナTCN */
    alloc = _ma_recycle (alloc, &size);

#else

    long more;				/* Kvȃq[v̗ */
    char *alloc;			/* V蓖ăAhX */

    /*
    ** ubN̍Ō̃AhX𓾂BubN̍Ōオ
    ** o^ĂȂ悤ȂA_hsta + 4 lƂēo^B
    ** A_hsta 擪ʎq 4 oCgށB
    */
    if ((alloc = _ma_lptr) == 0) {
	alloc = _hsta + 4;
	MA_BFLAG (alloc) = MA_VALUE (MA_EXIT, 0);
    }

    /*
    ** ubN̍Ō̃AhX size oCgq[v̈
    ** ɊmۂƂꍇɑȂ̃oCgvZB
    */
    more = alloc + size + 4 - (char *) _last;

    /*
    ** ȂʂȂΗ̈g傷B̍ہAu[Nl
    ** ̓y[WTCY(4K)o_ŊgBŌ̏I[
    **  4 oCg܂ށBgɎsꍇ̓G[^[B
    */
    if (more > 0) {
	if ((int) sbrk (more) < 0)
	    return 0;
    }

    /*
    ** VɎZoubNubNI[ƂA
    ** ɏI[ʎq𖄂ߍށB
    */
    _ma_lptr = alloc + size;
    MA_FFLAG (_ma_lptr) = MA_VALUE (MA_EXIT, 0xffffff);

#endif

    /*
    ** AhXԂB
    */
    return alloc;
}
