/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _splitpath.c,v 1.4 1993/08/16 13:36:06 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <ctype.h>
#include <stdlib.h>
#include <sys/xglob.h>

/* Functions */
void _splitpath (const char *name, char *drv, char *path, char *node, char *ext)
{
    unsigned char *e, *t;
    char xname[PATH_MAX + 1];

    /* XbVɕϊ */
    _toslash (strcpy (xname, name));

    /* Tp|C^ */
    t = xname;

    {
	/* hCu邩? */
	if (t[0] && t[1] == ':') {

	    /* hCu */
	    *drv++ = toupper (*t++);
	    *drv++ = *t++;
	}
	*drv = '\0';
    }

    {
	/* pX؂L邩? */
	if ((e = strrchr (t, '/')) == 0)
	    path[0] = '\0';

	/* pXo */
	else {
	    *e++ = '\0';
	    strcat (strcpy (path, t), "/");
	    t = e;
	}
    }

    {
	/* O . 邢 ..  */
	if (t[0] == '.' && (t[1] == '\0' || (t[1] == '.' && t[2] == '\0'))) {
	    strcpy (node, t);
	    ext[0] = '\0';
	}

	/* gq邩? */
	else if ((e = strrchr (t, '.')) == 0 || e == t) {
	    strcpy (node, t);
	    ext[0] = '\0';
	}

	/* t@CƊgqo */
	else {
	    strcpy (ext, e);
	    *e = '\0';
	    strcpy (node, t);
	}
    }
}
