/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: bsearch.c,v 1.2 1994/05/02 16:52:08 mura Exp $
 */

/* System headers */
#include <stdlib.h>

/* Functions */
void *bsearch (const void *item, const void *array, size_t number,
	       size_t size, int (*comparison) (const void *, const void *))
{
    int rc;
    int left, mid, right;
    const void *ptr;

    /* E̔r̈}[J[ */
    left = 0;
    right = number - 1;

    /* ̈}[JdȂ܂Ō */
    while (left <= right) {

	/* r̒ԓ_Zo */
	mid = (left + right) >> 1;

	/* rΏۃf[^ fetch  */
	ptr = (const void *) ((const char *) array + size * mid);

	/* item Ɣr */
	rc = (*comparison) (ptr, item);

	/* rʂɉčẼ}[Jړ */
	if (rc < 0)
	    left = mid + 1;
	else if (rc > 0)
	    right = mid - 1;
	else
	    return (void *) ptr;
    }

    /* Ȃ */
    return 0;
}
