/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: free.c,v 1.3 1994/07/27 13:50:15 mura Exp $
 */

/* System headers */
#include <stdlib.h>
#include <errno.h>
#include <sys/xstdlib.h>

#ifdef __LIBC_SX__
#include<stdio.h>

/* File scope functions */
static inline int SX_DISPOSE_PTR (char *p)
{
    register int result asm("d0");
    asm volatile("move.l %1,-(sp)\n\t"
		 "dc.w $a02f\n\t"
		 "addq.w #4,sp"
		    : "=r" (result)
		    : "g"(p)
		    : "a0");
    return result;
}
#endif

/* Functions */
void free (void *ptr)
{
    void *curr_block;
    void *next_block;
    size_t curr_size;
    size_t prev_size;

    /*
    ** ptr  NULL ȂΉȂ
    */
    if (ptr == 0)
	return;

    /*
    ** ̃ubNgp̃ubNł邩ǂׂBA
    ** `FbN͔ɂ܂Ȃ̂łAK͂ł
    ** B
    */
    curr_block = MA_TOPADR (ptr);
    curr_size = MA_MASK (MA_FFLAG (curr_block));
    if (MA_ISUSED (curr_block) == 0) {
	errno = EFAULT;
	return;
    }

    /*
    ** ̃ubN𒲂ׂB󂫃ubNȂ΁A
    ** ̋󂫃ubNXg폜ÃubNƈ
    ** ɂB
    */
    next_block = curr_block + curr_size;
    if (MA_ISFREE (next_block)) {
	curr_size += MA_FASTMASK (MA_FFLAG (next_block));
	_ma_remove (next_block);
    }

    /*
    ** ÕubN𒲂ׂB󂫃ubNȂ΁A
    ** ̋󂫃ubNgẴubNƈꏏɂB
    ** ܂Ƃ߂邱Ƃŋ󂫃ubNXg̑𖳂B
    */
    if (MA_ISFREE (MA_BACKADR (curr_block))) {
	prev_size = MA_FASTMASK (MA_BFLAG (curr_block));
	MA_BFLAG (curr_block + curr_size) = MA_VALUE (MA_FREE, curr_size + prev_size);
	MA_FFLAG (curr_block - prev_size) = MA_VALUE (MA_FREE, curr_size + prev_size);
#ifdef __LIBC_SX__
	curr_block -= prev_size;
	curr_size += prev_size;
#endif
    }

    /*
    ** ubN󂫃ubNƂB
    */
    else {
	MA_BFLAG (curr_block + curr_size) = MA_VALUE (MA_FREE, curr_size);
	MA_FFLAG (curr_block) = MA_VALUE (MA_FREE, curr_size);
	_ma_add (curr_block);
    }

#ifdef __LIBC_SX__
    /*
    ** ubNq[vŜȂ炱폜
    */
    {
	if (MA_RMASK (MA_BFLAG (curr_block)) == MA_EXIT &&
	    MA_RMASK (MA_FFLAG (curr_block + curr_size)) == MA_EXIT) {
	    char **c_heap;
	    char **p_heap;

	    _ma_remove (curr_block);
	    c_heap = (char **) (curr_block - 8);

	    /* q[vXg폜 */
	    p_heap = &_ma_lptr;
	    do {
		if (*p_heap == (char *) c_heap)
		    break;
	    } while ((p_heap = (char **) *p_heap));
	    *p_heap = *c_heap;
	    SX_DISPOSE_PTR ((char *) c_heap);
	}
    }
#endif
}
