/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: ltoa.c,v 1.1 1993/05/06 13:04:48 mura Exp $
 */

/* System headers */
#include <stdlib.h>

/* Functions */
char *ltoa (long value, char *string, int radix)
{
    int sign;
    char *p, *q;
    char buffer[32];
    static char digits[] = "0123456789abcdefghijklmnopqrstuvwxyz";

    /* ͈̓`FbN */
    if (radix < 2 || radix > 36) {
	*string = '\0';
	return string;
    }

    /* p  buffer ̍Ō + 1  */
    p = buffer + sizeof (buffer);

    /*  */
    if (value >= 0)
	sign = 0;
    else {
	sign = 1;
	value = -value;
    }

    /* value  0 ɂȂ܂ŕϊ */
    do {
	*--p = digits[value % radix];
	value /= radix;
    } while (value > 0);

    /* ݒ */
    if (sign)
	*--p = '-';

    /* buffer  string փRs[ */
    q = string;
    do {
	*q++ = *p++;
    } while (p < buffer + sizeof buffer);

    /* null Ń^[~l[g */
    *q = '\0';

    /* string Ԃ */
    return string;
}
