/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: malloc.c,v 1.2 1994/11/26 14:58:32 mura Exp $
 */

/* System headers */
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <sys/xstdlib.h>

/*
**
** gpubN̍\
** ~~~~~~~~~~~~~~~~~~~~
**
** ma_bflag                                      
** 
** 
** ma_fflag (4 byte signed int)                  
**  1 oCg: gpʃtO MA_USED (0x77)
**  3 oCg: ubÑTCY\         
** 
** [U[ɗ^郁̈                    
**                                               
**        ubNTCY - 8 oCg              
**                                               
** 
** ma_bflag (4 byte signed int)                  
** e ma_fflag ƓB̃ub
** N獂ɂ̃ubN̏𒲂ׂ邽߂ɂ
** B̃ubN̐擪AhX|
** ̃ubNTCYÕubN̐擪Ah
** XłBԂ݂͑łȂB            
** 
** 
** ma_fflag                                      
**
**
** 󂫃ubN̍\
** ~~~~~~~~~~~~~~~~~~
**
** ma_bflag                                      
** 
** 
** ma_fflag (4 byte signed int)                  
**  1 oCg: 󂫎ʃtO MA_FREE (0x00)  
**  3 oCg: ubÑTCY\         
** 
** ma_prev (4 byte char *)                       
** oN\ɂĈŐ󂫃u
** bN̐擪AhX                            
** 
** ma_next (4 byte char *)                       
** oN\ɂĈ̋󂫃u
** bN̐擪AhX                          
** 
** gp̈                                    
**                                               
**        ubNTCY - 16 oCg             
**                                               
** 
** ma_bflag (4 byte signed int)                  
** e ma_fflag ƓB̃ub
** N獂ɂ̃ubN̏𒲂ׂ邽߂ɂ
** B̃ubN̐擪AhX|
** ̃ubNTCYÕubN̐擪Ah
** XłBԂ݂͑łȂB            
** 
** 
** ma_fflag                                      
**
**
** 擪AyяI[̍\
** ~~~~~~~~~~~~~~~~~~~~
**
** ma_bflag                                      
**  1 oCg: [_ʃtO MA_EXIT (0x7f)  
**  3 oCg: 擪ʎq (0x000000)          
** 
** 
** ma_fflag                                      
**  1 oCg: [_ʃtO MA_EXIT (0x7f)  
**  3 oCg: 擪ʎq (0xffffff)          
**
**
** F󂫃ubN̍\A ŒubNTCY
**      16 oCgA[U[̈ 0 ̃ubN
**     ȂǎgɂȂȂ̂ŁA ŒTCY  32
**     oCgɋK肷B ܂ATCY 16 oCg
**     PʂɊۂ߂B
*/

/* Functions */
void *malloc (size_t size)
{
    char *aloc_block;

    /*
    ** TCY␳A 16 ̔{ɂȂ悤ɂB
    */
    size += 8;
    size = MA_ADJUST (size);

    /*
    ** 󂫃ubNXgɓK؂ȃTCY̋󂫃ubN邩ǂ
    ** TBtȂ炻̃ubN𒲐čėpB
    */
    if ((aloc_block = _ma_search (size)) != NULL)
	aloc_block = _ma_recycle (aloc_block, &size);

    /*
    ** tȂȂ烁ubN̍ŌɐV
    ** ubN쐬B
    */
    else if ((aloc_block = _ma_new (size)) == 0) {
	errno = ENOMEM;
	return 0;
    }

    /*
    ** ubNgpƂB
    */
    MA_FFLAG (aloc_block) = MA_VALUE (MA_USED, size);
    MA_BFLAG (aloc_block + size) = MA_VALUE (MA_USED, size);

    /*
    ** ubÑ[U[̈̃AhXԂB
    */
    return MA_MPTR (aloc_block);
}
