/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: putenv.c,v 1.3 1994/07/27 13:50:23 mura Exp $
 */

/* System headers */
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/xstart.h>

/* Functions */
int putenv (const char *string)
{
    size_t len, size;
    char *equal, *new;
    char **ptr;

    /* = Ȃꍇ̓G[ */
    if ((equal = strchr (string, '=')) == 0) {
	errno = EINVAL;
	return -1;
    }

    /* = ̌낪󕶎̏ꍇ͂̊ϐ폜 */
    if (equal[1] == '\0') {

	/* string ̒𒲂ׂ */
	len = strlen (string) - 1;

	/* ϐ string 폜 */
	for (ptr = environ; *ptr; ptr++)
	    if (strncmp (*ptr, string, len) == 0 && (*ptr)[len] == '=') {
		do {
		    ptr[0] = ptr[1];
		} while (*++ptr);
		break;
	    }

	/* ĂȂĂ */
	return 0;

    }

    /* ݒl̒𒲂ׂ */
    len = equal - string;

    /* ϐTAe[ȗ傫v */
    for (ptr = environ, size = 0; *ptr; ptr++, size++)
	if (strncmp (*ptr, string, len) == 0 && (*ptr)[len] == '=')
	    break;

    /* Ȃ΁A̒lύX */
    if (*ptr) {

	/* string n̈ȊÖʒuwĂ malloc ꂽ̂ł낤 */
	if (*ptr < (char *) _esta || *ptr >= (char *) _fsta)
	    free (*ptr);

	/* Vɗ̈mۂ */
	if ((new = strdup (string)) == 0)
	    return -1;

	/* |C^ */
	*ptr = new;

	/* I */
	return 0;

    }

    /* ǉpɐVzmۂ */
    if ((ptr = (char **) malloc ((size + 2) * sizeof (char *))) == 0)
	return -1;

    /* 𕡐 */
    if ((new = strdup (string)) == 0) {
	free (ptr);
	return -1;
    }

    /* ݂̊ϐe[uVe[uɃRs[ */
    memcpy (ptr, environ, size * sizeof (char *));

    /* w肳ꂽ̒ǉiŏIGgƂȂj*/
    ptr[size] = new;
    ptr[size + 1] = 0;

    /* Âϐe[u폜 */
    if (environ != _fsta)
	free (environ);

    /* environ XV */
    environ = ptr;

    /* I */
    return 0;
}
