* -*-Fundamental-*-
*
* PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
* --------------------------------------------------------------------
* This file is written by the Project C Library Group,  and completely
* in public domain. You can freely use, copy, modify, and redistribute
* the whole contents, without this notice.
* --------------------------------------------------------------------
* based on the contribution by TomY.
* --------------------------------------------------------------------
* $Id: qsort.s,v 1.2 1994/05/02 16:52:51 mura Exp $
*

		.xdef		_qsort

		.xref		_errno

~tmp		.reg		d0		* ėp 1
~tmp2		.reg		d1		* ėp 2
~mtmp		.reg		d1		* Zp 1
~mtmp2		.reg		d2		* Zp 2
~usize		.reg		d3		* PʗvfTCY
~left		.reg		d4		* ԗvf
~num		.reg		d5		* ԗvf
~tmp3		.reg		d6		* ėp 3
~dbconst	.reg		d7		* dbra 萔
~tmpptr		.reg		a0		* ėp|C^ 1
~tmpptr2	.reg		a1		* ėp|C^ 2
~leftptr	.reg		a3		* |C^
~middleptr	.reg		a4		* l|C^
~rightptr	.reg		a5		* E|C^
~cmpfunc	.reg		a6		* r֐
~qstack		.reg		sp		* X^bN|C^

MULU_L		.macro		src,dst,srch,dsth
		.if		CPU>=68020
		mulu.l		src,dst
		.else
		swap.w		src
		move.w		src,srch
		swap.w		src
		swap.w		dst
		move.w		dst,dsth
		swap.w		dst
		mulu.w		dst,srch
		mulu.w		src,dsth
		mulu.w		src,dst
		swap.w		dst
		add.w		srch,dst
		add.w		dsth,dst
		swap.w		dst
		.endif
		.endm

SWAPMEM		.macro		ptr1,ptr2,ctr,tmp,dbcon
		.local		loop
		subq.l		#1,ctr
loop:		move.b		(ptr1),tmp
		move.b		(ptr2),(ptr1)+
		move.b		tmp,(ptr2)+
		.if		CPU>=68020
		subq.l		#1,ctr
		.else
		dbra		ctr,loop
		sub.l		dbcon,ctr
		.endif
		bcc		loop
		.endm

		.offset		0

QS_saveregs:	.ds.l		8+7
QS_return:	.ds.l		1
QSARG_base:	.ds.l		1
QSARG_num:	.ds.l		1
QSARG_size:	.ds.l		1
QSARG_cmpfunc:	.ds.l		1

QS_SAVEREGS	.reg		d0-d7/a0-a6

EINVAL		.equ		14

		.ifndef		CPU
CPU:		.equ		68000
		.endif

		.cpu		CPU

		.text

_qsort:
		* WX^̑ޔ

		movem.l		QS_SAVEREGS,-(sp)

		* vf 0A1 ̃`FbN

		moveq.l		#1,~tmp
		cmp.l		QSARG_num(sp),~tmp
		beq		end
		bhi		error
quick_sort:
		* ̃[h

		move.l		QSARG_num(sp),~num
		move.l		QSARG_size(sp),~usize
		movea.l		QSARG_cmpfunc(sp),~cmpfunc
		movea.l		QSARG_base(sp),~leftptr

		* ŏIvf|CǧvZ

		move.l		~num,~tmp
		subq.l		#1,~tmp
		MULU_L		~usize,~tmp,~mtmp,~mtmp2
		lea.l		(~leftptr,~tmp.l),~rightptr

		* dbra 萔̃Zbg

		.if		CPU<68020
		move.l		#$0001_0000,~dbconst
		.endif

		* X^bNɃXgbp[ς

		clr.l		-(~qstack)
		clr.l		-(~qstack)
		clr.l		-(~qstack)
qs_mloop:
		* vf 2 ̃`FbN

		moveq.l		#2,~tmp
		cmp.l		~tmp,~num
		beq		qs_two

		* vf 1A3 ̃`FbN

		moveq.l		#3,~tmp
		cmp.l		~tmp,~num
		bhi		qs_main
		bcs		qs_popstack
qs_three:
		* vf 3 ̓ʏ

		lea.l		(~leftptr,~usize.l),~middleptr

		*  2 r

		move.l		~leftptr,-(sp)
		move.l		~middleptr,-(sp)
		jsr		(~cmpfunc)
		addq.l		#8,sp
		tst.l		d0
		bpl		qs_three_2

		* 

		movea.l		~leftptr,~tmpptr
		movea.l		~middleptr,~tmpptr2
		move.l		~usize,~tmp
		SWAPMEM		~tmpptr,~tmpptr2,~tmp,~tmp2,~dbconst
qs_three_2:
		* E 2 r

		move.l		~middleptr,-(sp)
		move.l		~rightptr,-(sp)
		jsr		(~cmpfunc)
		addq.l		#8,sp
		tst.l		d0
		bpl		qs_popstack

		* 

		movea.l		~middleptr,~tmpptr
		move.l		~usize,~tmp
		SWAPMEM		~tmpptr,~rightptr,~tmp,~tmp2,~dbconst

		* Ăэ 2 rɂ

		movea.l		~middleptr,~rightptr
qs_two:
		* vf 2 ̓ʏ

		move.l		~leftptr,-(sp)
		move.l		~rightptr,-(sp)
		jsr		(~cmpfunc)
		addq.l		#8,sp
		tst.l		d0
		bpl		qs_popstack

		* 

		move.l		~usize,~tmp
		SWAPMEM		~leftptr,~rightptr,~tmp,~tmp2,~dbconst
qs_popstack:
		* X^bNvfEE|Cgo

		movem.l		(~qstack)+,~num/~leftptr/~rightptr

		* Xgbp[oI

		move.l		~rightptr,~tmp
		beq		end

		* vf 2A3 ̃`FbN

		moveq.l		#3,~tmp
		cmp.l		~tmp,~num
		bcs		qs_two
		beq		qs_three
qs_main:
		* vf 4 ȏ̏

		* E|Cg̕ۑ

		movem.l		~leftptr/~rightptr,-(sp)

		* l|CǧvZ

		move.l		~leftptr,~tmp
		add.l		~rightptr,~tmp
		btst.l		#0,~num
		bne		qs_main_2
		sub.l		~usize,~tmp
qs_main_2:
		lsr.l		#1,~tmp
		movea.l		~tmp,~middleptr
		moveq.l		#0,~left

		* vf̌[v
qs_sloop:
		* ʒu̒T[v

		movem.l		~leftptr/~middleptr,-(sp)
		jsr		(~cmpfunc)
		move.l		d0,~tmp3
		bpl		qs_lloop_end
qs_lloop:
		addq.l		#1,~left
		adda.l		~usize,~leftptr
		movem.l		~leftptr/~middleptr,(sp)
		jsr		(~cmpfunc)
		move.l		d0,~tmp3
		bmi		qs_lloop
qs_lloop_end:
		* Eʒu̒T[v

		movem.l		~middleptr/~rightptr,(sp)
		jsr		(~cmpfunc)
		tst.l		d0
		bpl		qs_rloop_end
qs_rloop:
		suba.l		~usize,~rightptr
		movem.l		~middleptr/~rightptr,(sp)
		jsr		(~cmpfunc)
		tst.l		d0
		bmi		qs_rloop
qs_rloop_end:
		addq.l		#8,sp

		* E|C^vEĂI

		cmpa.l		~leftptr,~rightptr
		beq		qs_sloop_last_l
		bcs		qs_sloop_end
qs_swap:
		* E̗vfȂȂ

		or.l		d0,~tmp3
		bne		qs_swap_2
		adda.l		~usize,~leftptr
		bra		qs_swap_5

		* l|C^̃`FbNƍXV
qs_swap_2:
		cmpa.l		~leftptr,~middleptr
		bne		qs_swap_3
		movea.l		~rightptr,~middleptr
		bra		qs_swap_4
qs_swap_3:
		cmpa.l		~rightptr,~middleptr
		bne		qs_swap_4
		movea.l		~leftptr,~middleptr
qs_swap_4:
		* 

		movea.l		~rightptr,~tmpptr
		move.l		~usize,~tmp
		SWAPMEM		~leftptr,~tmpptr,~tmp,~tmp2,~dbconst
qs_swap_5:
		* |C^i߂

		suba.l		~usize,~rightptr
		addq.l		#1,~left

		* E|C^vEĂȂȂ烋[v

		cmpa.l		~leftptr,~rightptr
		bhi		qs_sloop
qs_sloop_last:
		bne		qs_sloop_end

		* E|C^vȂ

		move.l		~leftptr,-(sp)
		move.l		~middleptr,-(sp)
		jsr		(~cmpfunc)
		addq.l		#8,sp

		* ̗vfǂ炩̋Ԃɓ

		tst.l		d0
		bmi		qs_sloop_last_r
qs_sloop_last_l:
		addq.l		#1,~left
		adda.l		~usize,~leftptr
		bra		qs_sloop_end
qs_sloop_last_r:
		suba.l		~usize,~rightptr
qs_sloop_end:
		* ̎_ōE|C^͌Ă

		* ̋Ԃ̍E|C^o

		movem.l		(sp)+,~tmp3/~tmpptr

		* Eԗvf̌vZ

		sub.l		~left,~num

		* Eԗvf̔r

		cmp.l		~num,~left
		bcs		qs_right
qs_left:
		* Ԃ̕傫ȂEԂɏ

		moveq.l		#1,~tmp
		cmp.l		~tmp,~left
		bls		qs_left_2

		* ԂX^bNɐς

		movem.l		~left/~tmp3/~rightptr,-(~qstack)
qs_left_2:
		* EԂZbg

***		move.l		~num,~num
***		movea.l		~leftptr,~leftptr
		movea.l		~tmpptr,~rightptr
		bra		qs_mloop
qs_right:
		* EԂ̕傫Ȃ獶ԂɏB

		moveq.l		#1,~tmp
		cmp.l		~tmp,~num
		bls		qs_right_2

		* EԂX^bNɐς

		exg.l		~tmpptr,~leftptr
		movem.l		~num/~tmpptr/~leftptr,-(~qstack)
qs_right_2:
		* ԂZbg

		move.l		~left,~num
***		movea.l		~rightptr,~rightptr
		movea.l		~tmp3,~leftptr
		bra		qs_mloop
error:
		* G[R[h̃Zbg

		moveq.l		#EINVAL,d0
		move.l		d0,_errno
end:
		* WX^̕A

		movem.l		(sp)+,QS_SAVEREGS
		rts

		.end
