/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * based on the contribution from Seirios.
 * --------------------------------------------------------------------
 * $Id: random.c,v 1.1.1.1 1993/04/18 16:24:40 mura Exp $
 */

/* System headers */
#include <stdlib.h>
#include <limits.h>

/* Macros */
#define _EXTENDBASE 16
#define _INDEX      55
#define _MID_INDEX  24
#define _SUB_INDEX  (_INDEX - _MID_INDEX)

/* File scope variables */
int randcnt = -1;
unsigned long randtable[_INDEX];
unsigned long randextend[_EXTENDBASE];

/* File scope functions */
static void subtractive_method (void);

/* Functions */
unsigned int random (void)
{
    unsigned int i, j;

    /* JE^Ȃ srandom (1) 𔭍s */
    if (randcnt < 0)
	srandom (1);

    /* e[u̍ĉZ */
    if (++randcnt >= _INDEX) {
	subtractive_method ();
	randcnt = 0;
    }

    /* pool e[ũf[^o */
    j = randtable[randcnt] % _EXTENDBASE;
    i = randextend[j];

    /* e[u̍ĉZ */
    if (++randcnt >= _INDEX) {
	subtractive_method ();
	randcnt = 0;
    }

    /* pool ̕ύX */
    randextend[j] = randtable[randcnt];

    return i;
}

/* Functions */
unsigned int srandom (unsigned int seed)
{
    int n, index;
    unsigned int temp;
    unsigned int old_seed;
    static unsigned long internal_seed;

    /* V[hۑ */
    old_seed = internal_seed;

    /* e[uSɃNA */
    for (n = 0; n < _INDEX; n++)
	randtable[n] = 0;
    for (n = 0; n < _EXTENDBASE; n++)
	randextend[n] = 0;

    /* V[hݒ肷 */
    randtable[_INDEX - 1] = internal_seed = seed;

    /* ݒ */
    temp = 1;

    /* e[ȕsȂ */
    for (n = 0; n < _INDEX - 1; n++) {
	index = ((_SUB_INDEX * (n + 1)) % _INDEX) - 1;
	randtable[index] = temp;
	temp = seed - temp;
	seed = randtable[index];
    }

    /* subtractive method Kp */
    for (n = 0; n < 4; n++)
	subtractive_method ();

    /* pool JE^̏ */
    randcnt = _INDEX;

    /*  pool ̏ */
    for (n = 0; n < _EXTENDBASE; n++) {
	randextend[n] = randtable[randcnt];
	if (++randcnt > _INDEX) {
	    subtractive_method ();
	    randcnt = 0;
	}
    }

    return old_seed;
}

/* File scope functions */
static void subtractive_method (void)
{
    int n;

    /* subtractive method ̉Z */
    for (n = 0; n <= _SUB_INDEX; n++)
	randtable[n] = randtable[n] - randtable[n + _SUB_INDEX];
    for (n = _INDEX - 30; n <= _INDEX; n++)
	randtable[n] = randtable[n] - randtable[n - _MID_INDEX];
}

/* EOF */
