/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: realloc.c,v 1.1.1.1 1993/04/18 16:24:43 mura Exp $
 */

/* System headers */
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/xstdlib.h>

/* Functions */
void *realloc (void *ptr, size_t n)
{
    void *curr_block;
    void *aloc_block;
    void *next_block;
    size_t curr_size;
    size_t next_size;

    /*
    ** ptr k|C^Ȃ malloc ƓB
    */
    if (ptr == 0)
	return malloc (n);

    /*
    ** ̃ubNgp̃ubNł邩ǂׂBA`
    ** FbN͔ɂ܂Ȃ̂łAK͂łȂB
    */
    curr_block = MA_TOPADR (ptr);
    if (MA_ISUSED (curr_block) == 0) {
	errno = EFAULT;
	return 0;
    }

    /*
    ** TCY n ̃ubÑTCY菬ꍇ͈ʒu͂
    ** ̂܂܁B
    */
    curr_size = MA_MASK (MA_FFLAG (curr_block));
    if (curr_size - MA_STRSIZ >= n)
	return ptr;

    /*
    ** ̃ubN𒲂ׂBꂪ󂫃ubNłA
    ** ƍ킹邱ƂŐVTCYɓKȂ΃ubN
    ** ZB
    */
    next_block = curr_block + curr_size;
    if (MA_ISFREE (next_block)) {
	next_size = MA_FASTMASK (MA_FFLAG (next_block));
	if (next_size + curr_size - MA_STRSIZ >= n) {
	    _ma_remove (next_block);
	    curr_size += next_size;
	    MA_FFLAG (curr_block) = MA_VALUE (MA_USED, curr_size);
	    MA_BFLAG (curr_block + curr_size) = MA_VALUE (MA_USED, curr_size);
	    return ptr;
	}
    }

    /*
    ** VubNmۂAubN̓eRs[A
    ** ŌɌÂubNBK[hEłA8o
    ** Cgo_Ȃ̂ long word ŃRs[B
    */
    if ((aloc_block = malloc (n)) != NULL) {
	int *dst = aloc_block;
	int *src = ptr;
	int copysize = (curr_size >> 2) - 2;
	while (copysize--) *dst++ = *src++;
	free (ptr);
    }

    /*
    ** AhXԂB
    */
    return aloc_block;
}
