/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: strtok.c,v 1.1.1.1 1993/04/18 16:25:56 mura Exp $
 */

/* System headers */
#include <stddef.h>
#include <string.h>

/* Functions */
char *strtok (char *str, const char *delim)
{
    unsigned char ch;
    char *token;
    static char *last;

    /* str == 0  last == 0 ̓G[ */
    if (str == 0 && (str = last) == 0)
	return 0;

    /* ̃f~^XLbv */
    while ((ch = *str++) != 0)
	if (strchr (delim, ch) == 0)
	    break;

    /* ̏I */
    if (ch == '\0') {
	last = 0;
	return 0;
    }

    /* g[NJnʒuL */
    token = str - 1;

    /* f~^̌ */
    while ((ch = *str++) != 0)
	if (strchr (delim, ch))
	    break;

    /* ̏I肩? */
    if (ch == '\0') {
	last = 0;
	return token;
    }

    /* f~^ʒu null Ŗ߂ */
    str[-1] = '\0';

    /* Ō̈ʒuLĖ߂ */
    last = str;

    return token;
}
