/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _exit.c,v 1.3 1994/07/27 13:51:07 mura Exp $
 */

/* System headers */
#include <unistd.h>
#include <stdio.h>
#include <sxlib.h>
#include <sys/xstart.h>
#include <sys/xsignal.h>
#include <sys/xprof.h>

/* External variables */
int _onexnums;
void (*_onexprcs[ONEXIT_MAX]) (void);

/* Functions */
void _exit (int ecode)
{
    int i;

    /* t@Cnh exit Ή */
    fcloseall ();

    /* ᐅt@Cnhׂĉ */
    closeall ();

    /* VOi~ */
    _sigend ();

    /* o^ꂽ֐At̏ԂɌĂяo */
    for (i = _onexnums - 1; i >= 0; i--)
	(*_onexprcs[i]) ();

    /* ubNvt@Cgp? */
    if (_bluse)
	__display_block_profile ();

    /* ֐vt@Cgp? */
    if (_fpuse)
	__display_function_profile ();

    /* SX ̃q[v */
    _sx_killheap ();

    /* f[^GA */
    MMHdlUnlock (_data_hdl2);
    MMHdlDispose (_data_hdl2);
    MMHdlUnlock (_data_hdl1);
    MMHdlDispose (_data_hdl1);
 
    /* I */
    TSExit (ecode);
}
