/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _sx_rinit.c,v 1.1 1993/10/06 16:51:56 mura Exp $
 */

/* System headers */
#include <string.h>
#include <sys/xstart.h>

/* Functions */
void **_sx_rinit (void)
{
    char **databuf_top_h;
    char *databuf_top;
    size_t rdata_sz, rbss_sz, rldata_sz, rlbss_sz;
    size_t rdata_top, rbss_top, rldata_top, rlbss_top;
    size_t databuf_sz;

    /* TCYvZ */
    rdata_sz = __size_info.rdata;
    rbss_sz = __size_info.rbss + __size_info.rcomm + __size_info.rstack;
    rldata_sz = __size_info.rldata;
    rlbss_sz = __size_info.rlbss + __size_info.rlcomm + __size_info.rlstack;

    /* ItZbgvZ */
    rdata_top = 0;
    rbss_top = rdata_top + rdata_sz;
    rldata_top = rbss_top + rbss_sz;
    rlbss_top = rldata_top + rldata_sz;

    /* f[^GAm */
    databuf_sz = rdata_sz + rbss_sz + rldata_sz + rlbss_sz;
    if ((databuf_top_h = (char **) MMChHdlNew (databuf_sz)) == 0)
	return 0;

    /* ??? */
    MMHdlLock ((void **) databuf_top_h);

    /* ??? */
    databuf_top = *databuf_top_h;

    {
	char *data_top;
	unsigned int i, offset;
	unsigned int *offset_table;

	/* rdata ̐擪vZ */
	data_top = (char *) &__size_info + __size_info.data;

	/* task  rdata_sec ɁArdata  rdata_sz ] */
	memcpy (databuf_top + rdata_top, data_top, rdata_sz);

	/* task  rbss_sec Arbss_sz NA */
	memset (databuf_top + rbss_top, 0, rbss_sz);

	/* task  rldata_sec ɁArldata  rldata_sz ] */
	memcpy (databuf_top + rldata_top, data_top + rdata_sz, rldata_sz);

	/* task  rbss_sec Arbss_sz NA */
	memset (databuf_top + rlbss_top, 0, rlbss_sz);

	/* offset AhXɒ */
	offset = (unsigned int) databuf_top + 0x8000;

	/* ??? */
	offset_table = (unsigned int *) (data_top + rdata_sz + rldata_sz);
	for (i = __size_info.roffset / 4; i > 0; i--)
	    *(unsigned int *) (databuf_top + *offset_table++) += offset;
    }

    /* |C^Ԃ */
    return (void **) databuf_top_h;
}
