/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: d_import.c,v 1.3 1993/10/06 17:05:55 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <string.h>
#include <sys/dos.h>
#include <sys/xdoseml.h>
#include <sys/xstart.h>

/* Structures and unions */
struct _memimg {
    struct _mep mep;
    struct _psp psp;
    char prog[0];
};

/* Macros */
#define MIN_VERSION (('V'<<24)|('1'<<16)|('2'<<8)|'0')	/* 'V120' */

/* File scope functions */
static void *_keeppr_search (const struct _memimg *ps, const char *str, int offset)
{
    int len = strlen (str);

    /* 擪̃ubN܂łǂ */
    while (ps->mep.parent_mp)
	ps = ps->mep.parent_mp;

    /* Ǘ|C^ǂ */
    while ((ps = ps->mep.next_mp) != NULL) {

	/* 풓vO TEXT  offset ʒu̕𒲂ׂ */
	if (*(unsigned char *) &ps->mep.parent_mp == 0xff) {
	    if (strncmp (ps->prog + offset, str, len) == 0) {

		/* eLXg̈̐擪AhXԂ */
		return (void *) ps->prog;
	    }
	}

    }

    /* NULL Ԃ */
    return NULL;
}

/* Functions */
int *_dos_importlnenv (void)
{
    static int *lnenv;
    static char chkflg;

    /* 풓`FbNςׂ݂ */
    if (chkflg == 0) {
	int ssp;

	/* `FbNς */
	chkflg++;

	/* X[p[oCU[[hֈڍs */
	ssp = _dos_super (0);

	/* lndrv  */
	lnenv = (int *) _keeppr_search ((const struct _memimg *) _memcp,
					"LNDRV", LNDRV_HEADER * sizeof (int));

	/* Âo[W͖ */
	if (lnenv && lnenv[LNDRV_VERSION] < MIN_VERSION)
	    lnenv = NULL;

	/* [U[[hֈڍs */
	if (ssp > 0)
	    _dos_super (ssp);

    }

    /* ̊Ԃ */
    return lnenv;
}
