/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _loadrlm.c,v 1.1.1.1 1993/04/18 16:36:50 mura Exp $
 */

/* System headers */
#include <stdlib.h>
#include <limits.h>
#include <sys/resource.h>
#include <sys/xstart.h>
#include <sys/xresource.h>

/* External variables */
struct rlimit _limits[RLIM_NLIMITS];

/* File scope functions */
static inline int _import (const char *env)
{
    char *ptr;

    /* ϐ琔lo */
    return (ptr = getenv (env)) ? atoi (ptr) : 0;
}

/* Functions */
void _loadrlimits (void)
{
    int i;
    struct rlimit *lim = _limits;

    /*
    ** RLIMIT_FSIZE  Human Főp[eBVTCY
    ** 16 GByte łANX^TCY 256k ܂ő傫łƂāA
    ** vZ 16774144 KByteB
    */

    /* RLIMIT ̐ݒ */
    lim[RLIMIT_CPU   ].rlim_max = RLIM_INFINITY;
    lim[RLIMIT_FSIZE ].rlim_max = 16774144U * 1024;
    lim[RLIMIT_DATA  ].rlim_max = _mmax - _hsta;
    lim[RLIMIT_STACK ].rlim_max = _stacksize;
    lim[RLIMIT_CORE  ].rlim_max = _import ("limit_core");
    lim[RLIMIT_RSS   ].rlim_max = _mmax - (void *) _memcp;
    lim[RLIMIT_NOFILE].rlim_max = OPEN_MAX;

    /* rlim_cur ̏l rlim_max ̕ */
    for (i = 0; i < RLIM_NLIMITS; i++)
	lim[i].rlim_cur = lim[i].rlim_max;
}
