/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _getinode.c,v 1.7 1994/11/26 15:06:12 mura Exp $
 */

/* System headers */
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <alloca.h>
#include <sys/dos.h>
#include <sys/stat.h>
#include <sys/xstat.h>
#include <sys/xglob.h>
#include <stdio.h>

/* Macros */
#define MAXDIRENTRY     (1024 / sizeof (direntry_t))
#define PASSCURDRV(x)   ((x) + 1)
#define HUMAN_CURDIRTBL ((drvtbl_t *) *(int *) 0x1c38)
#define VIRDIR          (0x60)

/* Functions */
void _getdpbsrc (int phydrv, dpbsrc_t *buf)
{
    int ssp;
    drvtbl_t *drvtbl;

    /* X[p[oCU[h */
    ssp = _dos_super (0);

    /* Human [ÑhCȕT */
    drvtbl = HUMAN_CURDIRTBL;
    memcpy (buf, (drvtbl + phydrv)->dpbsrcptr, sizeof (dpbsrc_t));

    /* ɖ߂ */
    if (ssp > 0)
	_dos_super (ssp);
}

/* Functions */
char _phydrv2drvno (char drv)
{
    /* hCuzue[u */
    char *drvtbl = (unsigned char *) 0x1c7e;
    char i;
    int ssp;

    /* X[p[oCU[ */
    ssp = _dos_super (0);

    /* hCu̔zu */
    for (i = 0; i < _MAX_DRVNO; i++) {
	if (drv == drvtbl[i])
	    break;
    }

    /* ɖ߂ */
    if (ssp > 0)
	_dos_super (ssp);

    /* i Ԃ */
    return i;
}

/* Functions */
int _iscdromdrive (int drive)
{
    int rc;
    struct _dpbptr dpb;
    unsigned char buffer[100];

    /* DPB obt@ɓǂݍ */
    if ((rc = _dos_getdpb (drive, &dpb)) < 0) {
	if (rc == _DOSE_ILGPARM) {
	    rc = _dos_ioctrlfdctl (drive, 0, buffer);
	    if (buffer[1] == 0xf5)
		return 1;
	}
    }

    /* CD-ROM ł͂Ȃ */
    return 0;
}

/* Functions */
int _getinode (struct _filbuf *fb, int wild)
{
    int pos, topsec, drv;
    direntry_t *direntry;
    dpbsrc_t dpbsrc;
    struct _namestbuf file;
    union {
	unsigned short no;
	unsigned char nob[2];
    } fat;

    /* DPB ̃^lobt@ɓǂݍ */
    _getdpbsrc (fb->driveno, &dpbsrc);

    /* direntry ̗̈mۂ */
    direntry = alloca (sizeof (direntry_t) * MAXDIRENTRY * (dpbsrc.sec + 1));

    /*
    ** fBNgGgǂݍށB
    ** ƁAȂ mount ꂽANZXł˂
    */

    {
	int asign, result;
	char drvbuf[3], pathbuf[PATH_MAX +1];

	/* hCuԍ߂ */
	drv = _phydrv2drvno (fb->driveno);
	drvbuf[0] = drv + 'A';
	drvbuf[1] = ':';
	drvbuf[2] = '\0';

	/* ATC𓾂 */
	if ((asign = _dos_getassign (drvbuf, pathbuf)) <= 0) {
	    errno = _errcnv (asign);
	    return -1;
	}

	/* zfBNg? */
	if (asign == VIRDIR)
	    if ((result = _dos_rassign (drvbuf)) < 0) {
		errno = _errcnv (result);
		return -1;
	    }

	/* ǂݍ */
	_dos_diskred2 (direntry, PASSCURDRV (drv), fb->dirsec, 1);

	/* zfBNg? */
	if (asign == VIRDIR) {

	    /* makeassign 悪 mount Ă邩Ȃ̂œWJ */
	    _fullpath (pathbuf, pathbuf, sizeof (pathbuf));

	    /* assign ɖ߂ */
	    if ((result = _dos_makeassign (drvbuf, pathbuf, VIRDIR)) < 0) {
		errno = _errcnv (result);
		return -1;
	    }

	}
    }

    /* 0xFFFF Ȃ... */
    if (fb->dirpos == 0xffff) {

	/* fb->name ̏擾 */
	_dos_namests (fb->name, &file);

	/* pos w肪Ȃ玩ŃGgT */
	for (pos = 0; pos < (MAXDIRENTRY << dpbsrc.shift); pos++) {

	    /* 폜t@C̓XLbv */
	    if ((unsigned char) direntry[pos].name1[0] == 0xe5)
		continue;

	    /* ? */
	    if (strncmp (direntry[pos].name1, file.name1, 8) == 0 &&
		strncmp (direntry[pos].ext, file.ext, 3) == 0 &&
		strncmp (direntry[pos].name2, file.name2, 10) == 0)
		break;

	}
    }
    else {

	/* ChJ[h̏ꍇ̓G[ */
	if(wild != WILD_TRUE) {
	    errno = ENOENT;
	    return -1;
	}

	/* |WVvZ */
	pos = fb->dirpos / sizeof (direntry_t);

    }

    /* FATԍ쐬 */
    fat.no = direntry[pos].fatno;
    fat.no = fat.nob[1] << 8 | fat.nob[0];

    /* FATNO = 0 ȁH */
    if (fat.no == 0) {

	/* {[x̓Gĝ */
	if (_DOS_ISVOL (fb->atr))
	    topsec = 0;

	/* [gfBNg */
	else
	    topsec = dpbsrc.dirsec;

    }

    /* FATԍZN^(NX^)ԍɕϊ */
    else
	topsec = dpbsrc.datasec + ((int) (fat.no - 2) << dpbsrc.shift);

    /* inode Ԃ */
    return MAKEINODE (drv, topsec);
}
