/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * written 1997.2.2 by K.Okabe.
 * --------------------------------------------------------------------
 * $Id$
 */

/* System headers */
#include <sys/time.h>
#include <sys/iocs.h>
#include <time.h>

/* Functions */
int gettimeofday (struct timeval *tv, struct timezone *tz)
{
    struct timeval tv_tmp;

    if (tv == NULL)
	tv = &tv_tmp;

    tv->tv_sec = (long) time ((time_t *) NULL);
#if 0
    tv->tv_usec = (long) (_iocs_ontime () % 100) * 1000000;
#else
    tv->tv_usec = 0L;
#endif

    if (tz) {
	struct tm *tmloc = localtime ((time_t *) &tv->tv_sec);

	tz->tz_minuteswest = - tmloc->tm_gmtoff / 60;
	tz->tz_dsttime = tmloc->tm_isdst;
    }

    return 0;
}
