/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * written 1997.2.2 by K.Okabe.
 * --------------------------------------------------------------------
 * $Id$
 */

/* System headers */
#include <sys/time.h>
#include <sys/dos.h>
#include <sys/xtime.h>
#include <time.h>

/* Functions */
int settimeofday (struct timeval *tv, struct timezone *tz)
{
    int year, month, day;
    int hour, min, sec;

    {
	struct tm *tmloc = localtime ((time_t *) &tv->tv_sec);

	year = tmloc->tm_year + 1900;
	month = tmloc->tm_mon + 1;
	day = tmloc->tm_mday;
	hour = tmloc->tm_hour;
	min = tmloc->tm_min;
	sec = tmloc->tm_sec;
    }

    if (year < 1980 || year > 2079
     || month < 1 || month > 12
     || day < 1 || day > _getmday (month - 1, year)
     || hour < 0 || hour > 23
     || min < 0 || min > 59
     || sec < 0 || sec > 59)
        return -1;

    _dos_setdate (((year - 1980) << 9) | (month << 5) | day);
    _dos_settim2 ((hour << 16) | (min << 8) | sec);

    return 0;
}
