/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: getclock.c,v 1.1 1993/11/13 06:36:49 mura Exp $
 */

/* System headers */
#include <sys/timers.h>
#include <sys/iocs.h>
#include <time.h>
#include <errno.h>
#ifdef TIMER_CHECKER
#include <limits.h>
#endif

/* Functions */
int getclock (int clock_type, struct timespec *tp)
{

    /* `FbN */
    if (tp == 0) {
	errno = EINVAL;
	return -1;
    }

    /* NbN^Cvɂ蕪 */
    switch (clock_type) {

    case TIMEOFDAY:			/*  */
	tp->tv_sec  = (unsigned long) time (0);
	tp->tv_nsec = 0L;
	break;

    case UPTIME:			/* N̎ */
	{
	    struct _ontime t = _iocs_ontime2 ();

#ifdef TIMER_CHECKER
	    int day_max = (ULONG_MAX / 86400) - (t.sec > (ULONG_MAX % 86400));

	    /* G[`FbN */
	    if (t.dat > day_max) {
		tp->tv_sec  = ULONG_MAX;
		tp->tv_nsec = 0L;
		break;
	    }
#endif
	    tp->tv_sec  = (t.day * 86400) + (t.sec / 100);
	    tp->tv_nsec = (t.sec % 100) * 10000000;
	    break;
	}

    default:				/* ȊO */
	errno = EINVAL;
	return -1;

    }

    /* I */
    return 0;
}
