/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: gmtime.c,v 1.1.1.1 1993/04/18 16:38:27 mura Exp $
 */

/* System headers */
#include <time.h>
#include <sys/xtime.h>

/* External variables */
struct tm _gmtm;

/* Functions */
struct tm *gmtime (const time_t *caltime)
{

    /* tm \̂ɕϊ */
    _gmtm = _gmtime (caltime);

    /* tm \̂ւ̃|C^Ԃ */
    return &_gmtm;
}

/* Functions */
struct tm _gmtime (const time_t *caltime)
{
    int year, mon, day;
    time_t tick, ytik;
    struct tm gmtm;

    /* bo */
    tick = *caltime;

    /* ܂Ab߂ */
    gmtm.tm_sec = tick % 60;
    tick /= 60;
    gmtm.tm_min = tick % 60;
    tick /= 60;
    gmtm.tm_hour = tick % 24;
    tick /= 24;

    /* j߂ */
    gmtm.tm_wday = (tick + 4) % 7;

    /* JE^̏ */
    ytik = tick;
    year = 1970;
    mon  = 0;

    /* NєN̒ʂ߂ */
    while (tick >= (day = _getmday (mon, year))) {
	tick -= day;
	if (++mon >= 12) {
	    ytik -= _isleap (2, year) ? 366 : 365;
	    mon = 0;
	    year++;
	}
    }

    /* ߂f[^ݒ肷 (UTC ͏ isdst = 0) */
    gmtm.tm_yday   = ytik;
    gmtm.tm_year   = year - 1900;
    gmtm.tm_mon    = mon;
    gmtm.tm_mday   = tick + 1;
    gmtm.tm_isdst  = 0;
    gmtm.tm_gmtoff = 0;
    gmtm.tm_zone   = "GMT";

    /* tm \̂Ԃ */
    return gmtm;
}
