/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: time.c,v 1.1.1.1 1993/04/18 16:38:34 mura Exp $
 */

/* System headers */
#include <stdlib.h>
#include <time.h>
#include <sys/dos.h>
#include <sys/xtime.h>

/* File scope functions */
static time_t tmtosec (struct tm *t)
{
    int y, m, d;
    int h, i, s;

    /* tm \̂̒l 1900 N̑Βl */
    y = t->tm_year + 1900;

    /* 0  11 */
    m = t->tm_mon;

    /* 0  31 zQƂׁ̈A-1 */
    d = t->tm_mday - 1;

    /* 0  23 */
    h = t->tm_hour;

    /* 0  59 */
    i = t->tm_min;

    /* 0  61 */
    s = t->tm_sec;

    /* tm \̂̃`FbN */
    if (y < 1970 ||
	m < 0 || m > 11 ||
	d < 0 || d >= _getmday (m, y) ||
	h < 0 || h > 23 ||
	i < 0 || i > 59 ||
	s < 0 || s > 61)
	return -1;

    /* ̔NɂǍ̂̓܂ł̃g[^ */
    d += _getyday (m, y);

    /* 1970/01/01 ̃g[^ */
    d += 365 * (y - 1970) + _getleaps (y);

    /* ߂l͕bȂ̂ŌvZ */
    return 86400 * d + 3600 * h + 60 * i + s;
}

/* Functions */
time_t time (time_t *timeptr)
{
    struct tm t;
    time_t retval;
    unsigned long getdate;
    unsigned long gettime;

    /* DOS R[œtƎԂ𒲂ׂ */
    getdate = _dos_getdate ();
    gettime = _dos_gettim2 ();

    /* tm \̂ɕϊ */
    t.tm_year = ((getdate >> 9) & 0x7f) + 80;
    t.tm_mon  = ((getdate >> 5) & 0x0f) - 1;
    t.tm_mday = (getdate & 0x01f);
    t.tm_wday = (getdate >> 16);
    t.tm_hour = (gettime >> 16);
    t.tm_min  = (gettime >> 8) & 0x0ff;
    t.tm_sec  = (gettime & 0x0ff);

    /* tm \̂bɕϊ */
    if ((retval = tmtosec (&t)) >= 0) {

	/* VXeNbN JST Ȃ̂ JST->UTC ֋t␳ */
	retval += _TZADJUST;

    }

    /* timeptr ɔ[߂ */
    if (timeptr)
	*timeptr = retval;

    return retval;
}
