/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _finit.c,v 1.2 1993/05/06 13:43:32 mura Exp $
 */

/* System headers */
#include <fcntl.h>
#include <sys/dos.h>
#include <sys/xunistd.h>

/* Functions */
void _finit (void)
{
    int i;
    struct _handles *lp = &_fddb[0];

    /* Wt@Cnh */
    for (i = 0; i < 5; i++, lp++) {

	static const char _ttynames[5][4] = {
	    "con",			/* STDIN */
	    "con",			/* STDOUT */
	    "con",			/* STDERR */
	    "aux",			/* STDAUX */
	    "prn"			/* STDPRN */
	};

	static const unsigned char _ttymodes[5] = {
	    O_RDONLY | O_BINARY,	/* STDIN */
	    O_WRONLY | O_BINARY,	/* STDOUT */
	    O_WRONLY | O_BINARY,	/* STDERR */
	    O_RDWR   | O_BINARY,	/* STDAUX */
	    O_WRONLY | O_BINARY		/* STDPRN */
	};

	(void) _open (_ttynames[i], i, _ttymodes[i]);
	lp->inuse = _FD_IMPORTED;

	/* [foCXȂeLXg[hɂ */
	if (lp->cdev && (lp->iomd & (_DEV_STDIN | _DEV_STDOUT))) {
	    lp->oflag &= ~(O_TEXT | O_BINARY);
	    lp->oflag |= O_TEXT;
	}
    }
}
