/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: access.c,v 1.2 1993/09/16 15:29:08 mura Exp $
 */

/* System headers */
#include <errno.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/xglob.h>
#include <sys/xunistd.h>

/* Functions */
int access (const char *fname, int mode)
{
    int rc, result;
    struct stat st;
    char path[PATH_MAX + 1];

    /* pX̍Ō / 菜 */
    _dellastsep (strcpy (path, fname));

    /* path  stat  */
    rc = stat (path, &st);

    /* F_OK `FbN̏ꍇƃG[̏ꍇ͏I */
    if ((mode == F_OK) || (rc < 0))
	return rc;

    /* tONA */
    result = 0;

    /* R_OK `FbN */
    if (mode & R_OK)
	result += (st.st_mode & S_IREAD);

    /* W_OK `FbN */
    if (mode & W_OK)
	result += (st.st_mode & S_IWRITE);

    /* X_OK `FbN */
    if (mode & X_OK)
	result += (st.st_mode & S_IEXEC);

    /* ANZX`FbŇʂ́u_v*/
    if (result == 0) {
	errno = EACCES;
	return -1;
    }

    /* I */
    return 0;
}
