/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: getdcwd.c,v 1.2 1993/05/21 14:11:24 mura Exp $
 */

/* System headers */
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include <errno.h>
#include <string.h>
#include <sys/dos.h>
#include <sys/xglob.h>
#include <sys/xunistd.h>

/* Functions */
char *getdcwd (int drive, char *buff, int size)
{
    int rc, len;
    char cwd[PATH_MAX + 1];

    /* EINVAL `FbN */
    if (size < 1) {
	errno = EINVAL;
	return 0;
    }

    /* 擪 /  */
    cwd[0] = '/';

    /* JgfBNg𒲂ׂ */
    if ((rc = _dos_curdir (drive, cwd + 1)) < 0) {
	errno = _errcnv (rc);
	return 0;
    }

    /* Ŝ̒𒲂ׂ */
    len = strlen (cwd) + 1;

    /* buff  NULL Ȃ malloc  */
    if (buff == 0) {

	/* Œ size oCg̃TCY߂ */
	size = max (len, size);

	if ((buff = (char *) malloc (size)) == 0)
	    return 0;

    }

    /* ERANGE `FbN */
    if (size < len) {
	errno = ERANGE;
	return 0;
    }

    /* f[^Rs[ */
    return strcpy (buff, _toslash (cwd));
}
