/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: lseek.c,v 1.4 1994/11/26 15:11:13 mura Exp $
 */

/* System headers */
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/dos.h>
#include <sys/xglob.h>
#include <sys/xunistd.h>

/* Macros */
#define EXPSTEPSIZ 1024

/* Functions */
off_t lseek (int fileno, long offset, int whence)
{
    long curpos, eofpos;
    long target;
    long rc, step;
    char zero[EXPSTEPSIZ];

#ifdef EBADF_CHECKER
    /* sȃt@Cnh`FbN */
    if (_usedfd (fileno) < 0) {
	errno = EBADF;
	return -1;
    }
#endif

    /* LN^foCXł̓V[NłȂ */
    if (_fddb[fileno].cdev) {

	/* eLXg EOF }[J[ */
	_fddb[fileno].oflag &= ~O_TXTEOF;

	/* V[NłȂĂG[ł͂Ȃ */
	return 0;

    }

    /* ݈ʒuƁAŌ̈ʒu߂ */
    curpos = _dos_seek (fileno, 0, 1);
    eofpos = _dos_seek (fileno, 0, 2);

    /* ڕWʒu߂ */
    if (whence == 1)
	target = curpos + offset;
    else if (whence == 2)
	target = eofpos + offset;
    else if (whence == 0)
	target = offset;
    else {
	errno = EINVAL;
	return -1;
    }

    /* ItZbg`FbN */
    if (target < 0) {
	errno = EINVAL;
	return -1;
    }

    /* EOF zĂ̊g */
    if (target > eofpos) {

	/* ݂ł̂ */
	if (_writable (fileno) < 0) {
	    errno = EBADF;
	    return -1;
	}

	/* ݗp̃kf[^쐬 */
	memset (zero, '\0', EXPSTEPSIZ);

	/* target ܂Ńkf[^ */
	while (eofpos < target) {
	    step = target - eofpos;
	    step = (step > EXPSTEPSIZ) ? EXPSTEPSIZ : step;
	    eofpos += step;
	    if ((rc = _dos_write (fileno, zero, step)) < 0) {
		errno = _errcnv (rc);
		return -1;
	    }
	}

    }
    else {

	/* ɃV[N */
	if ((rc = _dos_seek (fileno, target, 0)) < 0) {
	    errno = _errcnv (rc);
	    return rc;
	}

	/* eLXg EOF }[J[ */
	_fddb[fileno].oflag &= ~O_TXTEOF;

    }

    return target;
}
