/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: unlink.c,v 1.8 1994/11/26 15:13:01 mura Exp $
 */

/* System headers */
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <sys/dos.h>
#include <sys/xglob.h>
#include <sys/xunistd.h>

/* Functions */
int unlink (const char *path)
{
    int i, ssp, check;
    int devattr, fd;
    unsigned char entryidx;
    unsigned long dirsec;
    unsigned short fatno;
    void *deventry;
    union _fcb fblock, *np;

    /* e|ɃI[v */
    if ((fd = _dos_open (path, 0)) < 0) {

	/* fBNg? */
	if (fd == _DOSE_ISDIR) {

	    /* fBNg폜Ă݂ */
	    if (_dos_rmdir (path) >= 0)
		return 0;

	}

	/* ŇȂfBNgւ̃V{bNN */
	if (_dos_delete (path) >= 0)
	    return 0;

	/* ͂G[ */
	errno = _errcnv (fd);
	return -1;

    }

    /* foCX߂ */
    devattr = _dos_ioctrlgt (fd);

    /* FCB ߂āAN[Y */
    ssp = _dos_super (0);
    memcpy (&fblock, _dos_getfcb (fd), sizeof (union _fcb));
    if (ssp > 0) _dos_super (ssp);

    /* N[Y */
    _dos_close (fd);

    /* LN^foCX͍폜łȂ */
    if (devattr & _DEV_CDEV) {
	errno = EDEVFS;
	return -1;
    }

    /* READONLY t@C͍폜łȂ */
    if (fblock.blk.attr & (_DOS_IRDONLY | _DOS_ISYS)) {
	errno = EPERM;
	return -1;
    }

    /* t@C̕hCuƐ擪 FAT ߂ */
    deventry = fblock.blk.deventry;
    entryidx = fblock.blk.entryidx;
    dirsec   = fblock.blk.dirsec;
    fatno    = fblock.blk.fatno;

    /* ݃I[vĂt@CQ̒ɂ邩? */
    for (check = i = 0; i < OPEN_MAX; i++) {

	/* o^Ăt@C FCB */
	np = &_fddb[i].fcb;

	/* o^Ăf[^Əƍ */
	if (np->blk.deventry == deventry &&
	    np->blk.entryidx == entryidx &&
	    np->blk.dirsec   == dirsec &&
	    np->blk.fatno    == fatno) {

	    /* unlink tOݒ */
	    _fddb[i].unlink = 1;

	    /* \`FbNtOZ */
	    check++;

	}

    }

    /* ȂȂÂ܂܍폜Ăǂ */
    if (check == 0 && (fd = _dos_delete (path)) < 0) {
	errno = _errcnv (fd);
	return -1;
    }

    /* I */
    return 0;
}
