/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: write.c,v 1.3 1993/08/16 13:42:10 mura Exp $
 */

/* System headers */
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/dos.h>
#include <sys/xglob.h>
#include <sys/xunistd.h>

/* Macros */
#define TXWRITEBUFSIZ 2048

/* Functions */
int write (int fileno, const char *buffer, unsigned int bytes)
{
    int cpos, rc, count;
    int eof, decr, flag;
    char *wp, *rp;
    char wbuf[TXWRITEBUFSIZ + 1];

    /* sȃt@Cnh`FbN */
    if (_writable (fileno) < 0) {
	errno = EBADF;
	return -1;
    }

    /* 0 oCgȂ牽sȂ */
    if (bytes <= 0)
	return 0;

    /* APPEND Ȃ΃t@C̍ŌɃV[N */
    if ((flag = _fddb[fileno].oflag) & O_APPEND) {
	if (_seekeof (fileno, flag) < 0)
	    return -1;
    }

    /* oCi[h̏ */
    if (flag & O_BINARY) {

	/* oCi[hł͂ */
	if ((count = _dos_write (fileno, buffer, bytes)) < 0) {
	    errno = _errcnv (count);
	    return -1;
	}

	/* G[? */
	else if (count != bytes) {
	    errno = ENOSPC;
	    return -1;
	}

    }
    else {

	/* ϐ */
	decr = bytes;
	rp = (char *) buffer;
	wp = wbuf;
	eof = cpos = count = 0;

	/* IɂȂ܂ŏ */
	while (!eof) {

	    /* LF->CR/LF ϊ */
	    if (*rp == '\n') {
		*wp++ = '\r';
		cpos++;
	    }

	    /* obt@ɓ] */
	    *wp++ = *rp++;
	    cpos++;
	    count++;

	    /* SϊI EOF */
	    if (--decr <= 0)
		eof = 1;

	    /* obt@O */
	    if (eof || cpos >= TXWRITEBUFSIZ) {

		/* obt@̓eo */
		if ((rc = _dos_write (fileno, wbuf, cpos)) < cpos) {

		    /* SɃG[Ȃ... */
		    if (rc < 0) {
			errno = _errcnv (rc);
			return -1;
		    }

		    /* łȂ... */
		    else {

			/* ۂɏ񂾃oCgԂ */
			return count - cpos + rc;

		    }

		}

		/* JE^ */
		cpos = 0;
		wp = wbuf;

	    }

	}

    }

    /* ߂ */
    return count;
}
